﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Assetlink
{
	public enum OMErrorObjectType
	{
		ENTITYTYPE		            = 0,
		FACETTYPE		            = 1,
		ENTITY			            = 2,
		FACET			            = 3,
        NAMEDHIERARCHY              = 4,
        ASSOFIELDNAMEDHIERARCHY     = 5,
		ASSOCIATION			        = 6,
        ACCESSORROLE		        = 7,
        ACCESSRULE			        = 8,
        ACCESSRULECLAUSE	        = 9,
        AUTHORIZATION		        = 10,
        TABLE				        = 11,
        UNIQUEID			        = 12,
		PARSER				        = 13,
		OBJECTQUEUE			        = 14,
		GETDATAQUERYBUILDER         = 15,
        OBJECTMANAGERINTERFACE      = 16,
        OPERATION                   = 17,
        OBJECTMANAGERCLASS          = 18,
        DATAVALIDATOR               = 19,
        FILESYSTEM                  = 20,
        //For XML Manager.
        XMLMANAGER                  = 21,
        DATAACCESSLAYER             = 22,
        //For DeferredQueriesData class
        DEFERREDQUERY               = 23,
        // For OM ODS Class
        OBJECTMANAGER_ODS_CLASS     = 24,
        ODSASSOFIELDNAMEDHIERARCHY  = 25
	}

    public enum OMTransactionType
    {
        READ  = 0,
        WRITE = 1
    }

	public enum OMErrorType
	{
		ERROR		= 0,
		EXCEPTION	= 1,
        WARNING     = 2
	}

    public enum OMErrorCodes
    {
        ENTITY_TYPE_NOT_FOUND                               = 0,
        ENTITY_TYPE_CREATION_FAILED                         = 1,
        ENTITY_TYPE_READ_FAILED                             = 2,
        ENTITY_TYPE_MODIFICATION_FAILED                     = 3,
        ENTITY_TYPE_DELETION_FAILED                         = 4,
        ENTITY_NOT_FOUND                                    = 5,
        ENTITY_CREATION_FAILED                              = 6,
        ENTITY_READ_FAILED                                  = 7,
        ENTITY_MODIFICATION_FAILED                          = 8,
        ENTITY_DELETION_FAILED                              = 9,
        FACET_TYPE_NOT_FOUND                                = 10,
        FACET_TYPE_CREATION_FAILED                          = 11,
        FACET_TYPE_READ_FAILED                              = 12,
        FACET_TYPE_MODIFICATION_FAILED                      = 13,
        FACET_TYPE_DELETION_FAILED                          = 14,
        FACET_NOT_FOUND                                     = 15,
        FACET_CREATION_FAILED                               = 16,
        FACET_READ_FAILED                                   = 17,
        FACET_MODIFICATION_FAILED                           = 18,
        FACET_DELETION_FAILED                               = 19,
        NAMEDHIERARCHY_READ_FAILED                          = 20,
        NAMEDHIERARCHY_NOT_FOUND                            = 21,
        NAMEDHIERARCHY_CREATION_FAILED                      = 22,
        NAMEDHIERARCHY_MODIFICATION_FAILED                  = 23,
        NAMEDHIERARCHY_DELETION_FAILED                      = 24,
        ASSOCIATION_NOT_FOUND                               = 25,
        ASSOCIATION_READ_FAILED                             = 26,
        ASSOCIATION_EXSISTS                                 = 27,
        ASSOCIATION_ALREADY_EXSISTS                         = 28,
        ASSOCIATION_CREATION_FAILED                         = 29,
        ASSOCIATION_MODIFICATION_FAILED                     = 30,
        ASSOCIATION_DELETION_FAILED                         = 31,
        ACCESS_DENIED                                       = 32,
        EXCEPTION_OCCURED                                   = 33,
        ACCESSORROLE_CREATION_FAILED                        = 34,
        ACCESSORROLE_NOT_FOUND                              = 35,
        ACCESSORROLE_DELETION_FAILED                        = 36,
        ACCESSORROLE_UPDATE_FAILED                          = 37,
        ACCESSORROLE_READ_FAILED                            = 38,
        ACCESSRULE_CREATION_FAILED                          = 39,
        ACCESSRULE_READ_FAILED                              = 40,
        ACCESSRULE_NOT_FOUND                                = 41,
        ACCESSRULE_DELETION_FAILED                          = 42,
        ACCESSRULE_UPDATE_FAILED                            = 43,
        ACCESSRULECLAUSE_CREATION_FAILED                    = 44,
        ACCESSRULECLAUSE_NOT_FOUND                          = 45,
        ACCESSRULECLAUSE_DELETION_FAILED                    = 46,
        ACCESSRULECLAUSE_UPDATE_FAILED                      = 47,
        ACCESSRULECLAUSE_READ_FAILED                        = 48,
        AUTHORIZATION_CREATION_FAILED                       = 49,
        AUTHORIZATION_DELETION_FAILED                       = 50,
        AUTHORIZATION_UPDATE_FAILED                         = 51,
        AUTHORIZATION_NOT_FOUND                             = 52,
        TABLE_CREATION_FAILED                               = 53,
        CREATE_RECORD_FAILED                                = 54,
        READ_RECORD_FAILED                                  = 55,
        UPDATE_RECORD_FAILED                                = 56,
        DELETE_RECORD_FAILED                                = 57,
        GENERALDB_FAILURE                                   = 58,
        UNIQUEID_GENERATION_FAILED                          = 59,
        GETDATA_FAILED                                      = 60,
        OMI_EXECUTE_FAILED                                  = 61,
        OMI_GETDATA_FAILED                                  = 62,
        OMI_GETFILES_FAILED                                 = 63,
        OMI_GETTYPEDATA_FAILED                              = 64,
        OPERATION_OBJECTNAME_INVALID                        = 65,
        OPERATION_METHODNAME_INVALID                        = 66,
        OPERATION_OPERATION_INVALID                         = 67,
        OPERATION_WRONG_PARAMETERCOUNT                      = 68,
        OPERATION_PARAMETER_NOTFOUND                        = 69,
        DATAVALIDATOR_XML_INVALID                           = 70,
        TABLE_UPDATION_FAILED                               = 71,
        OMCLASS_EXECUTE_FAILED                              = 72,
        OMCLASS_GETDATA_FAILED                              = 73,
        OMCLASS_GETDATATYPE_FAILED                          = 74,
        OMCLASS_GETFILES_FAILED                             = 75,
        FILESYSTEM_FILECREATION_FAILED                      = 76,
        FILESYSTEM_FILEMOVE_FAILED                          = 77,
        FILESYSTEM_FILEDELETE_FAILED                        = 78,
        FILESYSTEM_FILECOPY_FAILED                          = 79,
        FILESYSTEM_DIRCREATION_FAILED                       = 80,
        FILESYSTEM_DIRMOVE_FAILED                           = 81,
        FILESYSTEM_DIRDELETE_FAILED                         = 82,
        FILESYSTEM_DIRCOPY_FAILED                           = 83,
        FILESYSTEM_DIRFILECOUNT_FAILED                      = 84,
        FILESYSTEM_FILEUPDATION_FAILED                      = 85,
        FILESYSTEM_PROCESSFILESYSTEM_FAILED                 = 86,
        FILESYSTEM_BINDERCREATION_FAILED                    = 87,
        FILESYSTEM_BINDERDELETION_FAILED                    = 88,
        FILESYSTEM_BINDERFILEUPDATE_FAILED                  = 89,
        FILESYSTEM_ASSOCIATINGFILEWITHBINDER_FAILED         = 90,
        FILESYSTEM_DELETING_FILEBINDERASSOCIATION_FAILED    = 91,
        FILESYSTEM_UPDATING_FILEBINDERSEQUENCEORDER_FAILED  = 92,
        FILESYSTEM_BINDERUPDATION_FAILED                    = 93,
        FILESYSTEM_BINDEROPERATION_FAILED                   = 94,

        //For XML Manager.
        XMLMANAGER_SAVE_FAILED                      = 95,
        XMLMANAGER_LOAD_FAILED                      = 96,
        XMLMANAGER_DELETE_FAILED                    = 97,
        XMLMANAGER_COPYXSDFILE_FAILED               = 98,
        XMLMANAGER_RETRIEVEXSDFILE_FAILED           = 99,
        //For Authorization
        AUTHORIZATION_INVALID_INPUT_XML             = 100,

        //For Threshold results exceeding
        SEARCH_THRESHOLD_RESULTS_EXCEEDED           = 101,

        //For DeferredQueriesData class operations (DQ : Deferred Query)
        DQ_ASSEMBLYDATATABLE_INSERTRECORD_FAILED    = 102,
        DQ_ASSOCIATIONDATATABLE_INSERTRECORD_FAILED = 103,
        DQ_ASSEMBLYDATATABLE_READRECORD_FAILED      = 104,
        DQ_ASSOCIATIONDATATABLE_READRECORD_FAILED   = 105,
        DQ_DEFERREDQUERYDATATABLE_CLEANUP_FAILED    = 106,
        DQ_QUERYEXECUTION_FAILED                    = 107,
        DQ_NOQUERYTOEXECUTE                         = 108,

        //FileSystem Operation
        FILESYSTEM_FILEGETSIZE_FAILED           = 109,
        FILESYSTEM_DIRGETSIZE_FAILED            = 110,

        //Media Server
        MEDIASERVER_ACCESSDENIED                = 111, //If access to Media server is not permitted
        FILESYSTEM_FILE_NOT_FOUND               = 112, //

        // OMODSClass error codes which are used for ODS
        OMODSCLASS_EXECUTE_FAILED               = 113,
        ODS_TABLE_CREATION_FAILED               = 114,
        ODS_UPDATE_TABLE_FAILED                 = 115,
        ODS_DATAPOPUATIONSTOREDPROCEDURE_FAILED = 116,
        ODS_DROPSTOREDPROCEDURE_FAILED          = 117,
        ODS_CONFIGXML_UPDATE_FAILED             = 118,
        ODS_OBJECT_NOT_FOUND                    = 119,
        ODS_FIELDINFO_NOT_FOUND                 = 120,
        ODS_MOM_SCHEMA_FILE_NOT_FOUND           = 121,
        ODS_NAMEFIELDHIERARCHY_ASSOCIATION_CREATION_FAILED  =122,

        FILESYSTEM_DIRPATH_IN_AVOID_DELETE_LIST = 123

    }

	public enum OMFieldDataType
	{
		STRING = 0,
		BOOLEAN = 1,
		DATETIME = 2,
		INTEGER = 3,
		DECIMAL = 4,
        TEXT = 5,
	}
	public enum OMOperator
	{
		LIKE                = 0,
		EQUALTO             = 1,
		GREATERTHAN         = 2,
		LESSTHAN            = 3,
		GREATERTHANEQUALTO  = 4,
		LESSTHANEQUALTO     = 5,
		IN                  = 6,
		BETWEEN             = 7,
		NOTEQUALTO          = 8,
		NOTIN               = 9,
		NOTLIKE             = 10
	}
	public enum OMConjunction
	{
		AND = 0,
		OR = 1,
		NOTHING = 2
	}

    public enum OMPrivileges
    {
        // Old Privilege Values.
        //NOACCESS = 4,
        //READ    = 3,
        //WRITE   = 2,
        //DELETE  =1

        NOACCESS    = 1,
        READ        = 2,
        WRITE       = 3,
        DELETE      = 4,
        DENY        = 5

    }

    public enum OMSortOrder
    {
        ASC     = 0,
        DESC    = 1
    }

    public enum OMFileTransfer
    {
        ORIGINAL = 0,
        PREVIEW  = 1,
        THUMBNAIL= 2
    }

    public enum OMFileTransferMode
    {
        SYNCRONOUS = 0,
        ASYNCRONOUS = 1
    }

    public class OMConstant
    {
        public const String DEFAULT_RULE = "DEFAULT RULE";
    }

    /// <summary>
    /// Class used for maintaining internal data types for currency field.
    /// </summary>
    public static class OMInternalDataTypeForCurrency
    {
        public const String CURRENY_AMOUNT = "CURRENCY_A";
    }
    
	//public class CommonFunction
	//{

	//    public static Boolean DoesNodeExsists(string )
	//}
}
