#region Standard Include
using System;
using System.Text;
using System.Xml;
using System.IO;
using System.Collections;
using System.Collections.Specialized;
using System.Threading;
# endregion

#region Assetlink Include
using Assetlink.WebServices.ALInfrastructureWS;
using Assetlink;
using Assetlink.IOProxy;
#endregion

namespace Assetlink.Services.WindowsService
{
    using XML       = System.String;
    using ERRORXML  = System.String;
    using ENTITYID  = System.UInt64;

    public class Infrastructure
    {

        public static ERRORXML SystemConnect(String SystemUserName, String SystemUserPassword, ref String ImpersonationToken)
        {
            ERRORXML                ErrorXML                 = null;
            InfrastructureService   InfrastructureServiceObj = null;
            try
            {
                InfrastructureServiceObj    = new InfrastructureService();
                InfrastructureServiceObj.Url = ALCommon.GetWebServiceURL("ALInfrastructureWS");
                ErrorXML                    = InfrastructureServiceObj.SystemConnect(SystemUserName, SystemUserPassword, ref ImpersonationToken);
                return ErrorXML;
            }
            catch (Exception ExceptionObj)
            {
                throw ExceptionObj;
            }
        }

        public static ERRORXML ImpersonateUser(String LoginName, String TenantName, String ImpersonationToken, String CallerIdentity, ref ulong SessionID, ref String UserXML)
        {
            ERRORXML                ErrorXML                    = null;
            InfrastructureService   InfrastructureServiceObj    = null;
            try
            {
                InfrastructureServiceObj        = new InfrastructureService();
                InfrastructureServiceObj.Url    = ALCommon.GetWebServiceURL("ALInfrastructureWS");
                ErrorXML = InfrastructureServiceObj.ImpersonateUser(LoginName, TenantName, ImpersonationToken, ALCommon.GetLocalMachineIPAddress(), "INTERNAL", CallerIdentity, ref SessionID, ref UserXML);
                return ErrorXML;
            }
            catch (Exception ExceptionObj)
            {
                throw ExceptionObj;
            }
        }

        public static ERRORXML SignOut(ulong UserID,ulong SessionID,String Language, String TenantName)
        {
            ERRORXML                ErrorXML                    = null;
            ALServiceHeader         RequestHeader               = null;
            InfrastructureService   InfrastructureServiceObj    = null;
            try
            {
                InfrastructureServiceObj        = new InfrastructureService();
                RequestHeader                   = new ALServiceHeader();
                RequestHeader.UserID            = UserID;
                RequestHeader.SessionID         = SessionID;
                RequestHeader.TenantName        = TenantName;
                RequestHeader.Language          = Language;
                InfrastructureServiceObj.ALServiceHeaderValue = RequestHeader;
                InfrastructureServiceObj.Url    = ALCommon.GetWebServiceURL("ALInfrastructureWS");

                ErrorXML                        = InfrastructureServiceObj.SignOut();
                return ErrorXML;
            }
            catch (Exception ExceptionObj)
            {
                throw ExceptionObj;
            }
        }

        public static ERRORXML IsSessionValid(ENTITYID UserID,UInt64 SessionID,String Language, String TenantName, ref Boolean IsValid)
        {
            ERRORXML                ErrorXML                    = null;
            ALServiceHeader         RequestHeader               = null;
            InfrastructureService   InfrastructureServiceObj    = null;
            try
            {
                InfrastructureServiceObj    = new InfrastructureService();
                RequestHeader               = new ALServiceHeader();
                RequestHeader.UserID        = UserID;
                RequestHeader.SessionID     = SessionID;
                RequestHeader.TenantName    = TenantName;
                RequestHeader.Language      = Language;
                InfrastructureServiceObj.ALServiceHeaderValue = RequestHeader;
                InfrastructureServiceObj.Url = ALCommon.GetWebServiceURL("ALInfrastructureWS");

                ErrorXML                    = InfrastructureServiceObj.IsSessionValid(ref IsValid);
                return ErrorXML;
            }
            catch (Exception ExceptionObj)
            {
                throw ExceptionObj;
            }
        }

        public static bool DeleteFolder(String FolderPath, bool Recurrisive, ulong UserID, ulong SessionID, String Language, String TenantName, String AdditionalInfo)
        {
            //File.AppendAllText(ALCommon.GetInstallationDir() + "\\Logs\\ServiceCommon.txt", "Call to DeleteFolder");
            Context ObjContext = new Context(UserID, SessionID, TenantName, "", AdditionalInfo);
            bool CanDelete =  SASMOMDirectory.DeleteFolder(FolderPath, Recurrisive, ObjContext);
            //File.AppendAllText(ALCommon.GetInstallationDir() + "\\Logs\\ServiceCommon.txt", "Call completed DeleteFolder CanDelete:" + CanDelete.ToString());
            return CanDelete;
         
        }
    }
}
