using System;
using System.Collections;
using System.Collections.Generic;
using FluorineFx;
using FluorineFx.AMF3;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Xml.Serialization;
using System.Text;
using System.Xml;
using System.Xml.XPath;
using Assetlink.Solutions.Facade.MessageBoardFacade;
using Assetlink;
using Assetlink.Solutions;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.Solutions.Facade.UGMFacade;
using Assetlink.Solutions.Facade.PMFacade;

using Assetlink.IOProxy;
using iTextSharp.text;
using iTextSharp.text.pdf;
using iTextSharp.text.pdf.annotations;


namespace ALVisualAnnotation
{
    using XML       = System.String;
    using ERRORXML  = System.String;

    [RemotingService]
    public class RemoteService
    {

        #region Member Variables

        const String AttachmentFieldName    = "POSTATTACHMENTS";

        Post            obj_PostFacade      = null;
        FileFacade      obj_FileFacade      = null;
        FileTransfer    obj_FileTransfer    = null;
        
        
        enum AttachementType
        {
            Comments,
            Thumbnail,
            Background
        };

        #endregion

        #region Properties
        private const String DEFAULT_NONREVIEWER_COLOR = "0xFFFF00";//Yellow  "0xA0A0A0"; //Gray;
        private String m_SessionID = null;
        public String SessionID
        {
            get { return m_SessionID; }
            set { m_SessionID = value; }
        }

        private String m_UserID = null;
        public String UserID
        {
            get { return m_UserID; }
            set { m_UserID = value; }
        }

        private String m_TenantName = null;
        public String TenantName
        {
            get { return m_TenantName; }
            set { m_TenantName = value; }

        }

        private String m_Language;
        public String Language
        {
            get { return m_Language; }
            set { m_Language = value; }
        }

        private String m_DiscussionID = null;
        private String[] colorList = null;//new String[18] { "0x0085FF", "0x003593", "0x7C279C", "0xCE3C91", "0xFF95A3", "0xFF308E", "0xEE770F", "0xD6001A", "0x70C2EA", "0x9BCA26", "0x4AB600", "0x1D891C", "0x73410E", "0x95111E", "0xD0202A", "0xC18E5F", "0x808080", "0xFFFFFF" };        
        #endregion

        public void SaveThumbnail(string bitmapString)
        {
        }

        #region Comments Methods
        public String AddComment(ulong DiscussionID, string PostID, String obj_Comment, string sessionId, string language, string tenantName, string userId)
        {
            ERRORXML ErrorXML = null; 
            StringBuilder sb_ErrorMessage = null;
            StringBuilder PostXML = null;
            String outputXML = null;
            String DirPath = null;
           XmlDocument xmlDoc = null;
            XmlElement xmlEle_Binder = null;
            String CommentsXML = null;
            String inputXML = null;
            ulong tempID = 0;
            XmlDocument commentsDoc = null;
            Context ContextObj = null;
            StringBuilder sb_AdditionalInfo = null;
            try
            {
                SessionID = sessionId;
                Language = language;
                TenantName = tenantName;
                UserID = userId;
                
                sb_ErrorMessage = new StringBuilder(100);
                sb_AdditionalInfo = new StringBuilder(100);
                obj_PostFacade = new Post(SessionID, UserID, TenantName, Language);
                PostXML = new StringBuilder();
                if (!String.IsNullOrEmpty(PostID))
                {
                    ErrorXML = obj_PostFacade.GetPost(ulong.Parse(PostID), "<POST><" + AttachmentFieldName + "/></POST>", null, ref outputXML);
                    sb_AdditionalInfo.Append(@"<ADDITIONALINFO>
                                                        <APINAME>ALCC_ALVisualAnnotation.RemoteService.AddComment()</APINAME>
                                                        <THREADID>" + System.Threading.Thread.CurrentThread.ManagedThreadId.ToString() + "</THREADID>"
                                                        + outputXML 
                                                + "</ADDITIONALINFO>");
                    ContextObj = new Context(Convert.ToUInt64(userId), Convert.ToUInt64(sessionId), tenantName, "ALVisualAnnotation", sb_AdditionalInfo.ToString());
                    xmlDoc = new XmlDocument();
                    xmlDoc.LoadXml(outputXML);

                    xmlEle_Binder = (XmlElement)xmlDoc.SelectSingleNode("POST/FILESYSTEM/BINDER[FIELDNAME='" + AttachmentFieldName + "']");
                    xmlEle_Binder.SetAttribute("Operation", "UPDATE");
                    ((XmlElement)xmlEle_Binder.SelectSingleNode("FILE")).SetAttribute("Operation", "DELETE");
                    CommentsXML = PrepareFileNode(obj_Comment, ref DirPath);
                    xmlEle_Binder.InnerXml += CommentsXML;
                    inputXML = xmlDoc.InnerXml;
                }
                else
                {   
                    ALCommon.GenerateUniqueID(ref tempID);
                    PostXML.AppendFormat("<POST>");
                    PostXML.AppendFormat("<POSTID>{0}</POSTID>", tempID.ToString());
                    PostXML.AppendFormat("<POSTOWNER TYPE='RELATION'>{0}</POSTOWNER>", userId);
                    PostXML.AppendFormat("<TOPICPOST TYPE='RELATION'>{0}</TOPICPOST>", DiscussionID.ToString());

                    //Append Attachements
                    PostXML.AppendFormat("<FILESYSTEM>");
                    PostXML.AppendFormat("<BINDER Operation='Create'>");
                    PostXML.AppendFormat("<FIELDNAME>{0}</FIELDNAME>", AttachmentFieldName);
                    PostXML.AppendFormat("<NAME>{0}</NAME>", "MESSAGEBOARD_POST_ATTACHMENTS");

                    //Attach comments  

                    //update the postid in the attachement xml;
                    commentsDoc = new XmlDocument();
                    commentsDoc.LoadXml(obj_Comment);
                    commentsDoc.DocumentElement.SetAttribute("id", tempID.ToString());
                    obj_Comment = commentsDoc.InnerXml;
                    commentsDoc = null;

                    CommentsXML = PrepareFileNode(obj_Comment, ref DirPath);

                    PostXML.AppendFormat("{0}", CommentsXML);
                    PostXML.AppendFormat("</BINDER>");
                    PostXML.AppendFormat("</FILESYSTEM>");
                    PostXML.AppendFormat("</POST>");

                    inputXML = PostXML.ToString();
                }

                if (!String.IsNullOrEmpty(PostID))
                    ErrorXML = obj_PostFacade.UpdatePost(ref inputXML);
                else
                    ErrorXML = obj_PostFacade.SavePost(ref inputXML);

                if (String.IsNullOrEmpty(ErrorXML))
                {
                    if (String.IsNullOrEmpty(PostID))
                        PostID = tempID.ToString();
                    return PostID;
                }
                else
                {
                    return ErrorXML;
                }
            }
            catch (Exception obj_Exception)
            {
                sb_ErrorMessage.AppendFormat("{0}: {1}", Localization.GetString("ALErrorResource", TenantName, "EXCEPTION_shared"), obj_Exception.Message);
                return sb_ErrorMessage.ToString();
            }
            finally
            {
                try
                {
                    if (Directory.Exists(DirPath))
                    {
                        //Directory.Delete(DirPath);
                        SASMOMDirectory.DeleteFolder(DirPath, ContextObj);
                    }
                }
                catch
                {
                    //do nothing
                }
            }
        }

        private String PrepareFileNode(String obj_Comment, ref String DirPath)
        {
            StringBuilder sb_TempFilePath = new StringBuilder(150);
            StringBuilder sb_TempPath = new StringBuilder(150);
            StringBuilder FileContents = null;
            FileTransfer FileTransferObj = null;
            StringBuilder FileCollectionXML = null;
            String str_TempPath = null;
            ulong TempFolderID = 0;
            int AttachementOrder = 1;

            ALCommon.GenerateUniqueID(ref TempFolderID);               
            str_TempPath = ALSolutionCommon.GetTempPath(SessionID);

            sb_TempPath.AppendFormat("{0}\\{1}", str_TempPath.ToString(), TempFolderID);
            Directory.CreateDirectory(sb_TempPath.ToString());
            sb_TempFilePath.AppendFormat("{0}\\comments.xml", sb_TempPath.ToString());

            File.WriteAllText(sb_TempFilePath.ToString(), obj_Comment);

            FileTransferObj = new FileTransfer(SessionID, UserID, TenantName, Language);

            FileContents = new StringBuilder();
            FileContents.AppendFormat("<FILE Operation='CREATE' Order='{0}'>", AttachementOrder.ToString());
            FileContents.AppendFormat("<FIELDNAME>{0}</FIELDNAME>", AttachmentFieldName);
            FileContents.AppendFormat("<PATH>{0}</PATH>", sb_TempFilePath);
            FileContents.AppendFormat("<NAME>{0}</NAME>", "comments.xml");
            FileContents.AppendFormat("<DISPLAYNAME>{0}</DISPLAYNAME>", "comments.xml");
            FileContents.AppendFormat("</FILE>");

            FileCollectionXML = new StringBuilder();
            FileCollectionXML.AppendFormat("<FILECOLLECTION>{0}</FILECOLLECTION>", FileContents.ToString());
            string commentsXML = FileCollectionXML.ToString();

            FileTransferObj.SaveFile(ref commentsXML);
            DirPath = sb_TempPath.ToString();

            commentsXML = commentsXML.Replace("<FILECOLLECTION>", "");
            commentsXML = commentsXML.Replace("</FILECOLLECTION>", "");


            return commentsXML;
        }
        
        public String GetComment(ulong DiscussionId, ulong CommentID)
        {
            String         obj_Comment         = null;
            ERRORXML        ErrorXML            = null;
            XML             str_PostXML         = null;
            XPathDocument   xpDoc_Post          = null;
            XPathNavigator  xpNav_Post          = null;
            String          str_FilePath        = null;

            try
            {
                obj_PostFacade  = new Post(SessionID, UserID, TenantName, Language);
                ErrorXML        = obj_PostFacade.GetPost(CommentID, "", "", ref str_PostXML);

                if (String.IsNullOrEmpty(ErrorXML))
                {
                    xpDoc_Post = new XPathDocument(new StringReader(str_PostXML));
                    xpNav_Post = xpDoc_Post.CreateNavigator();

                    ErrorXML = GetFile(xpNav_Post, AttachementType.Comments, out str_FilePath);
                    if (String.IsNullOrEmpty(ErrorXML) && File.Exists(str_FilePath))
                    {
                        obj_Comment = File.ReadAllText(str_FilePath);
                    }
                }
            }
            catch (Exception obj_Exception)
            {
                string message = obj_Exception.Message;
            }
            return obj_Comment;

        }

        public List<string> GetCommentBackground(String Background_SchemaID, String Background_ObjectID, string sessionId, string language, string tenantName, string userId,string source,ulong commentId)
        {
            ERRORXML        ErrorXML                    = null;
            String          str_FilePath                = null;
            StringBuilder   sb_ErrorMessage             = null;
            StringBuilder   sb_FilePath                 = null;
            List<string>    returnList                  = new List<string>();
            
            
            SessionID = sessionId;
            Language = language;
            TenantName = tenantName;
            UserID = userId;

            try
            {
                returnList.Add(commentId.ToString());
                sb_FilePath = new StringBuilder(100);
                sb_ErrorMessage = new StringBuilder(100);
                ErrorXML  = GetFile(Background_ObjectID, "POSTATTACHMENTS",Background_SchemaID,"Background.png",false,out str_FilePath);
                sb_FilePath.AppendFormat("{0}{1}",ALSolutionCommon.GetHTTPDownloadFilePath(TenantName),str_FilePath.Substring(str_FilePath.LastIndexOf("\\")+1));

                if (!String.IsNullOrEmpty(ErrorXML))
                {
                    returnList.Add(ErrorXML.ToString());
                    returnList.Add(source);
                    return returnList;
                }
            }
            catch (Exception obj_Exception)
            {
                sb_ErrorMessage.AppendFormat("{0}: {1}", Localization.GetString("ALErrorResource", TenantName, "EXCEPTION_shared"), obj_Exception.Message);
                returnList.Add(sb_ErrorMessage.ToString());
                returnList.Add(source);
                return returnList;
            }
            returnList.Add(sb_FilePath.ToString());
            returnList.Add(source);
            return returnList;
        }

        public ERRORXML DeleteComment(String str_CommentIDList, string sessionId, string language, string tenantName, string userId)
        {
            StringBuilder   sb_CommentIDListXML     = null;
            String          CommentIDList           = null;
            ERRORXML        ErrorXml                = null;
            String[]        CommentIDs              = null;
            Post            obj_PostFacade          = null;

            try
            {
                SessionID = sessionId;
                Language = language;
                TenantName = tenantName;
                UserID = userId;

                obj_PostFacade      = new Post(SessionID, UserID, TenantName, Language);
                sb_CommentIDListXML = new StringBuilder();

                if (str_CommentIDList.Trim().Length > 0)
                {
                    CommentIDs = str_CommentIDList.Split(',');
                    sb_CommentIDListXML.AppendFormat("<POST>");
                    foreach (string PostID in CommentIDs)
                    {
                        sb_CommentIDListXML.AppendFormat("<POSTID>{0}</POSTID>", PostID);
                    }
                    sb_CommentIDListXML.AppendFormat("</POST>");
                    CommentIDList = sb_CommentIDListXML.ToString();

                    ErrorXml      = obj_PostFacade.DeletePost(CommentIDList.ToString(),"");
                    if (!String.IsNullOrEmpty(ErrorXml))
                    {
                        return ErrorXml;
                    }
                }
            }
            catch (Exception ExceptionObj)
            {
                ErrorXml =  ExceptionObj.Message;
            }
            return ErrorXml;
        }
        #endregion

        public String CreatePrintDocument(String annotations, ulong DiscussionId, string sessionId, string language, string tenantName, string themeName, string userId, bool IsImage, string printDisplayName)
        {
            ERRORXML            ErrorXML                        = null;
            String              str_TopicXML                    = null;
            StringBuilder       SearchBuilder                   = null;
            SearchConfiguration SearchConfigObj                 = null;
            XPathDocument       xpDoc                           = null;
            XPathNavigator      xpNav                           = null;
            XPathNavigator      xpNav_File                      = null;
            String              srcPath                         = null;
            String              TopicTitle                      = null;
            String              ProcessID                       = null;
            PMFacadeClass       PMFacadeObj                     = null;
            String              processAttrsXML                 = null;
            String              str_ProcessXML                  = null;
            String              tFile                           = null;
            String              str_Exception                   = "";
			UTF8Encoding		encode							= null;

            SessionID = sessionId;
            Language = language;
            TenantName = tenantName;
            UserID = userId;

			ALSolutionCommon.DecodeSpecialCharacters(ref printDisplayName);
			encode = new UTF8Encoding();
			printDisplayName = encode.GetString(Convert.FromBase64String(printDisplayName));

            SearchBuilder = new StringBuilder();
            SearchBuilder.Append("<SEARCH>");
            SearchBuilder.AppendFormat("<SESSIONINFO TenantName=\"{0}\" Language=\"{1}\" UserID=\"{2}\" SessionID=\"{3}\"/>", TenantName, Language, UserID, SessionID);
            SearchBuilder.Append(@"<TARGETOBJECT>TOPIC</TARGETOBJECT>
                                   <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                   <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                   <TARGETENTITY>
                                   <FILTERLIST>
                                   <FILTER>
                                    <FILTERID>1</FILTERID>
                                    <EXPRESSION>TOPICID</EXPRESSION>
                                    <OPERATOR>EQUALTO</OPERATOR>");
            SearchBuilder.AppendFormat("<EXPRESSIONVALUE>{0}</EXPRESSIONVALUE>", DiscussionId.ToString());
            SearchBuilder.Append(@"<ISCASESENSITIVE>False</ISCASESENSITIVE>
                                   </FILTER>
                                   </FILTERLIST>
                                   <SELECTLIST>
                                   <EXPRESSION><FIELDNAME>TOPICTITLE</FIELDNAME><ALIAS>TOPICTITLE</ALIAS></EXPRESSION>");
            if (IsImage)
                SearchBuilder.Append("<EXPRESSION><FIELDNAME>TOPICATTACHMENTS</FIELDNAME><ALIAS>TOPICATTACHMENTS</ALIAS></EXPRESSION>");

            SearchBuilder.Append(@"</SELECTLIST>
                                   <RELATIONSHIP NAME='TOPIC_REVIEWDETAILS'>
                                   <SELECTLIST><EXPRESSION><FIELDNAME>FILEFORAPPROVAL</FIELDNAME><ALIAS>FILEFORAPPROVAL</ALIAS></EXPRESSION>
                                   </SELECTLIST>
                                   </RELATIONSHIP>
                                   </TARGETENTITY>
                                   </SEARCH>");

            SearchConfigObj = new SearchConfiguration(SessionID, UserID, TenantName, Language);
            ErrorXML = SearchConfigObj.GetHierarchialData(SearchBuilder.ToString(), ref str_TopicXML);

            if (String.IsNullOrEmpty(ErrorXML))
            {
                xpDoc       = new XPathDocument(new StringReader(str_TopicXML));
                xpNav       = xpDoc.CreateNavigator();
                
                if (IsImage)
                    xpNav_File  = xpNav.SelectSingleNode("TOPICCOLLECTION/TOPIC/FILESYSTEM/BINDER/FILE");
                else
                {
                    xpNav_File  = xpNav.SelectSingleNode("TOPICCOLLECTION/TOPIC/TOPIC_REVIEWDETAILS/PROCESSREVIEWDETAILS/FILESYSTEM/FILE[FIELDNAME='FILEFORAPPROVAL']");                    

                    if (xpNav_File == null && xpNav.SelectSingleNode("TOPICCOLLECTION/TOPIC/TOPICTITLE") != null)
                    {
                        TopicTitle = xpNav.SelectSingleNode("TOPICCOLLECTION/TOPIC/TOPICTITLE").Value;
                        if (!String.IsNullOrEmpty(TopicTitle))
                        {
                            String[] TempArr    = TopicTitle.Split(new String[] { "_" }, StringSplitOptions.None);
                            ProcessID           = TempArr[1];

                            processAttrsXML     = "<WORKFLOWPROCESS><PROCESSFILE/></WORKFLOWPROCESS>";

                            PMFacadeObj         = new PMFacadeClass(SessionID, UserID, TenantName, Language);
                            ErrorXML            = PMFacadeObj.GetProcess(ProcessID, null, processAttrsXML, out str_ProcessXML);
                            if (String.IsNullOrEmpty(ErrorXML))
                            {
                                xpDoc       = new XPathDocument(new StringReader(str_ProcessXML));
                                xpNav       = xpDoc.CreateNavigator();
                                xpNav_File  = xpNav.SelectSingleNode("WORKFLOWPROCESS/FILESYSTEM/FILE[FIELDNAME='PROCESSFILE']");
                            }
                        }
                    }
                }
            }

            ErrorXML = GetSourceFile(xpNav_File, out srcPath);

           

            XmlDocument doc = new XmlDocument();
            doc.LoadXml(annotations);

            XmlNodeList annotationList = doc.GetElementsByTagName("annotations")[0].ChildNodes;

            XmlNodeList commentList = doc.GetElementsByTagName("comments")[0].ChildNodes;

            UTF8Encoding encoding = new UTF8Encoding();

            String annotationValue = "";
            Hashtable localComments = new Hashtable();

            String sourcePath = srcPath;
            ulong FileNameUniqueID = 0;
            ALCommon.GenerateUniqueID(ref FileNameUniqueID);
            String tempFile = ALSolutionCommon.GetDownloadFilePath(TenantName, SessionID) + FileNameUniqueID.ToString() + ".pdf"; ;
            String tempFileHTTPPath = ALSolutionCommon.GetHTTPDownloadFilePath(TenantName, SessionID) + FileNameUniqueID.ToString() + ".pdf"; ;
            // PdfDocument pdf = PdfReader.Open(sourcePath);

            if (IsImage)
            {

                float pageW = float.Parse(doc.DocumentElement.Attributes["w"].Value);
                float pageH = float.Parse(doc.DocumentElement.Attributes["h"].Value);

                Document imagePDF = new Document(new iTextSharp.text.Rectangle(pageW + 5f, pageH + 5f), 2.5f, 2.5f, 2.5f, 2.5f);

                ALCommon.GenerateUniqueID(ref FileNameUniqueID);
                tFile = ALSolutionCommon.GetDownloadFilePath(TenantName, SessionID) + FileNameUniqueID.ToString() + "_temp.pdf"; ;

                try
                {


                    PdfWriter.GetInstance(imagePDF, new FileStream(tFile, FileMode.Create));

                    imagePDF.Open();


                    using (FileStream fs = new FileStream(sourcePath, FileMode.Open))
                    {

                        iTextSharp.text.Image jpg = iTextSharp.text.Image.GetInstance(System.Drawing.Image.FromStream(fs), ImageFormat.Jpeg);
                        jpg.BorderWidth = 0f;
                        imagePDF.Add(jpg);

                    }

                }
                catch (DocumentException dex)
                {
                    str_Exception = dex.ToString();
                }

                catch (IOException ioex)
                {
                    str_Exception = ioex.ToString();
                }

                catch (Exception ex)
                {
                    str_Exception = ex.ToString();
                }

                finally
                {
                    imagePDF.Close();
                    sourcePath = tFile;
                }

            }
            else
            {
                FileStream inputFileStream = new FileStream(srcPath, FileMode.Open, FileAccess.Read);
                BinaryReader binaryReader = null;
                binaryReader = new BinaryReader(inputFileStream);

                //Remove Annotations if Present
                if (IsConsolidatedFile(binaryReader))
                {
                    sourcePath = srcPath.Substring(0, srcPath.LastIndexOf(".")) + "_temp.pdf";
                    using (Stream inputPdfStream = new FileStream(srcPath, FileMode.Open, FileAccess.Read, FileShare.Read))
                    using (Stream outputPdfStream = new FileStream(sourcePath, FileMode.Create, FileAccess.Write, FileShare.None))
                    {
                        var reader = new PdfReader(inputPdfStream);
                        reader.RemoveAnnotations();
                        var stamper = new PdfStamper(reader, outputPdfStream, '\0');
                        stamper.Close();
                    }
                }   
            }

            using (Stream inputPdfStream = new FileStream(sourcePath, FileMode.Open, FileAccess.Read, FileShare.Read))
            using (Stream outputPdfStream = new FileStream(tempFile, FileMode.Create, FileAccess.Write, FileShare.None))
            {
                var reader = new PdfReader(inputPdfStream);
                //reader.RemoveAnnotations(); // Remove all the Anotaions
                var pdf = new PdfStamper(reader, outputPdfStream, '\0');

                foreach (XmlNode comment in commentList)
                {

                    Hashtable o = null;
                    XmlAttribute data = comment.Attributes["data"];

                    string commentValue = encoding.GetString(Convert.FromBase64String(data.Value));

                    o = (Hashtable)Procurios.Public.JSON.JsonDecode(commentValue);

                    if (localComments[o["annoId"]] == null)
                    {
                        localComments[o["annoId"]] = new Hashtable();
                    }
                    (localComments[o["annoId"]] as Hashtable)[Convert.ToInt32((o["orderIndex"]))] = o;

                }


                foreach (XmlNode ann in annotationList)
                {
                    Hashtable o = null;
                    if (ann.Name == "anchor")
                    {
                        XmlAttribute data = ann.Attributes["data"];

                        annotationValue = encoding.GetString(Convert.FromBase64String(data.Value));

                        o = (Hashtable)Procurios.Public.JSON.JsonDecode(annotationValue);

                        AddAnchorAnnotation(o, localComments[o["guid"]] as Hashtable, pdf, reader);
                    }
                    if (ann.Name == "area")
                    {
                        XmlAttribute data = ann.Attributes["data"];

                        annotationValue = encoding.GetString(Convert.FromBase64String(data.Value));

                        o = (Hashtable)Procurios.Public.JSON.JsonDecode(annotationValue);
                        AddAreaAnnotation(o, localComments[o["guid"]] as Hashtable, pdf, reader);
                    }
                    if (ann.Name == "strikeout")
                    {
                        XmlAttribute data = ann.Attributes["data"];

                        annotationValue = encoding.GetString(Convert.FromBase64String(data.Value));

                        o = (Hashtable)Procurios.Public.JSON.JsonDecode(annotationValue);
                        AddStrikeoutAnnotation(o, localComments[o["guid"]] as Hashtable, pdf, reader);

                    }
                    if (ann.Name == "highlight")
                    {
                        XmlAttribute data = ann.Attributes["data"];

                        annotationValue = encoding.GetString(Convert.FromBase64String(data.Value));

                        o = (Hashtable)Procurios.Public.JSON.JsonDecode(annotationValue);
                        AddHighlightAnnotation(o, localComments[o["guid"]] as Hashtable, pdf, reader);
                    }
                    if (ann.Name == "text")
                    {
                        continue;
                        /*XmlAttribute data = ann.Attributes["data"];

                        annotationValue = encoding.GetString(Convert.FromBase64String(data.Value));

                        o = (Hashtable)Procurios.Public.JSON.JsonDecode(annotationValue);
                         */
                    }
                }

                pdf.Close();                
            }

            //Delete Temporary Files
            if (!String.IsNullOrEmpty(tFile))
            {
                if (File.Exists(tFile))
                    File.Delete(tFile);
            }
			
            printDisplayName = printDisplayName.Substring(0, printDisplayName.LastIndexOf(".")) + ".pdf";
            return prepareFileDownloadUrl(tempFileHTTPPath, printDisplayName);
            //return ALSolutionCommon.GetHTTPDownloadFilePath(TenantName) + sessionId + ".pdf";
        }

        private bool IsConsolidatedFile(BinaryReader binaryReader)
        {
            string SEPERATOR_TEXT = "$ALSEP$";
            int SEPERATOR_SIZE = 7;

            binaryReader.BaseStream.Position = binaryReader.BaseStream.Seek(-SEPERATOR_SIZE, SeekOrigin.End);

            byte[] buffer = new byte[SEPERATOR_SIZE];
            buffer = binaryReader.ReadBytes(SEPERATOR_SIZE);
            string almark = Encoding.UTF8.GetString(buffer);
            return (almark == SEPERATOR_TEXT);
        }

        /// <summary>
        /// Method to Get the Download File Http Path of the given file path
        /// </summary>
        private String prepareFileDownloadUrl(String FilePath, String DownloadFileName)
        {
            StringBuilder sb_DownloadPageUrl = new StringBuilder(100);
            sb_DownloadPageUrl.AppendFormat("/{0}/Common/ASPX/FileDownload.aspx?", TenantName);
            sb_DownloadPageUrl.AppendFormat("TenantName={0}&Language={1}&UserID={2}&SessionID={3}&FilePresent=Yes&HTTPPath={4}&DownloadFileName={5}", TenantName, Language, UserID, SessionID, FilePath, DownloadFileName);
            ALSolutionCommon ALSolutionCommonObj = new ALSolutionCommon();
            return ALSolutionCommonObj.EncodeURLForResponseRedirects(sb_DownloadPageUrl.ToString());
        }

        #region pdf printing



        private iTextSharp.text.Rectangle getBounds(PdfStamper stamper, int pageno, float W, float H, iTextSharp.text.Rectangle rect)
        {
            /* var llx = float.Parse(ann["x"].ToString());
              var lly = H - (float.Parse(ann["y"].ToString()) + float.Parse(ann["height"].ToString()));


              var urx = float.Parse(ann["x"].ToString()) + float.Parse(ann["width"].ToString());
              var ury = H - float.Parse(ann["y"].ToString());
             */

            var llx = rect.Left;
            var lly = H - rect.Bottom;


            var urx = rect.Right;
            var ury = H - rect.Top;



            float cbOriginX = 0;
            float cbOriginY = 0;
            if (stamper.Reader.GetBoxSize(pageno, "crop") != null)
            {
                cbOriginX = stamper.Reader.GetBoxSize(pageno, "crop").GetLeft(0);
                cbOriginY = stamper.Reader.GetBoxSize(pageno, "crop").GetBottom(0);
            }

            float mbOriginX = 0;
            float mbOriginY = 0;
            if (stamper.Reader.GetBoxSize(pageno, "media") != null)
            {
                mbOriginX = stamper.Reader.GetBoxSize(pageno, "media").GetLeft(0);
                mbOriginY = stamper.Reader.GetBoxSize(pageno, "media").GetBottom(0);
            }

            var originX = (cbOriginX > mbOriginX ? cbOriginX : mbOriginX);
            var originY = (cbOriginY > mbOriginY ? cbOriginY : mbOriginY);

            return new iTextSharp.text.Rectangle(originX + llx, originY + lly, originX + urx, originY + ury);
        }

        private void AddComments(PdfAnnotation ann, iTextSharp.text.Rectangle rect, Hashtable comments, PdfStamper stamper, int pageno)
        {
            for (int i = 1; i < comments.Count; i++)
            {
                Color replyclr = Color.FromArgb(Convert.ToInt32((comments[i] as Hashtable)["color"]));


                PdfAnnotation replyAnn = new PdfAnnotation(stamper.Writer, rect);
                replyAnn.Put(PdfName.SUBTYPE, PdfName.TEXT);
                replyAnn.Put(PdfName.TYPE, PdfName.ANNOT);
                replyAnn.Color = new BaseColor(replyclr);
                replyAnn.Put(PdfName.T, new PdfString(Convert.ToString((comments[i] as Hashtable)["authorName"]), PdfObject.TEXT_UNICODE));
                replyAnn.Put(PdfName.CONTENTS, new PdfString(Convert.ToString((comments[i] as Hashtable)["content"]), PdfObject.TEXT_UNICODE));


                string mydate = Convert.ToString((comments[i] as Hashtable)["lastModified"]).Replace("GMT", "");
				replyAnn.Put(PdfName.M, new PdfDate(DateTime.ParseExact(mydate, "ddd MMM dd HH:mm:ss zzzz yyyy", null)));
                replyAnn.Put(PdfName.IRT, ann.IndirectReference);

                // we add a reference to the text annotation to the popup annotation
                stamper.AddAnnotation(replyAnn, pageno);
            }

        }
        private void AddAnchorAnnotation(Hashtable o, Hashtable comments, PdfStamper stamper, PdfReader reader)
        {
            int pageno = Convert.ToInt16(o["PageNo"]);

            iTextSharp.text.Rectangle PageSize = reader.GetPageSize(reader.GetPageNRelease(pageno));
            float W = PageSize.Width;
            float H = PageSize.Height;

            iTextSharp.text.Rectangle orgRect = new iTextSharp.text.Rectangle(float.Parse(o["x"].ToString()),
                                                        float.Parse(o["y"].ToString()) + float.Parse(o["height"].ToString()),
                                                        float.Parse(o["x"].ToString()) + float.Parse(o["width"].ToString()),
                                                        float.Parse(o["y"].ToString()));
            iTextSharp.text.Rectangle rect = getBounds(stamper, pageno, W, H, orgRect);

            var cb = stamper.GetOverContent(pageno);

            Color clr = Color.FromArgb(Convert.ToInt32(o["color"]));

            PdfAnchorAnnotation anchorAnn = new PdfAnchorAnnotation(stamper.Writer);
            anchorAnn.Rectangle = rect;
            anchorAnn.Color = new BaseColor(clr);
            anchorAnn.Put(PdfName.T, new PdfString(Convert.ToString((comments[0] as Hashtable)["authorName"]), PdfObject.TEXT_UNICODE));
            anchorAnn.Contents = Convert.ToString((comments[0] as Hashtable)["content"]);
            anchorAnn.Open = true;
            string mydate = Convert.ToString((comments[0] as Hashtable)["lastModified"]).Replace("GMT", "");
            anchorAnn.DateTime = DateTime.ParseExact(mydate, "ddd MMM dd HH:mm:ss zzzz yyyy", null);

            // anchorAnn.Opacity = 0.001;
            //  anchorAnn.Flags = PdfAnnotation.FLAGS_READONLY;



            var x = (float.Parse(o["width"].ToString())) / 2 + 1;
            var y = (float.Parse(o["height"].ToString())) / 2 + 1;
            var r = float.Parse(o["width"].ToString()) / 2;

            PdfTemplate template = PdfTemplate.CreateTemplate(stamper.Writer, float.Parse(o["width"].ToString()) + 2f, float.Parse(o["height"].ToString()) + 2f);

            PdfShadingPattern pattern = new PdfShadingPattern(PdfShading.SimpleRadial(stamper.Writer, x, y, r - 2, x, y, r + 1, BaseColor.LIGHT_GRAY, BaseColor.WHITE));

            template.SetShadingFill(pattern);
            template.Circle(x, y, r + 1);
            template.Fill();
            template.SetRGBColorStroke(Color.White.R, Color.White.G, Color.White.B);
            template.SetRGBColorFill(clr.R, clr.G, clr.B);
            template.Circle(x, y, r);
            template.FillStroke();
            anchorAnn.SetAppearance(PdfAnnotation.APPEARANCE_NORMAL, template);

            stamper.AddAnnotation(anchorAnn, pageno);
            AddComments(anchorAnn, rect, comments, stamper, pageno);

        }

        private void AddAreaAnnotation(Hashtable o, Hashtable comments, PdfStamper stamper, PdfReader reader)
        {

            int pageno = Convert.ToInt16(o["PageNo"]);

            iTextSharp.text.Rectangle PageSize = reader.GetPageSize(reader.GetPageNRelease(pageno));
            float W = PageSize.Width;
            float H = PageSize.Height;

            iTextSharp.text.Rectangle orgRect = new iTextSharp.text.Rectangle(float.Parse(o["x"].ToString()),
                                                                   float.Parse(o["y"].ToString()) + float.Parse(o["height"].ToString()),
                                                                   float.Parse(o["x"].ToString()) + float.Parse(o["width"].ToString()),
                                                                   float.Parse(o["y"].ToString()));
            iTextSharp.text.Rectangle rect = getBounds(stamper, pageno, W, H, orgRect);

            var cb = stamper.GetOverContent(pageno);

            Color clr = Color.FromArgb(Convert.ToInt32(o["color"]));


            cb.SetRGBColorStroke(clr.R, clr.G, clr.B);

            rect.Border = iTextSharp.text.Rectangle.BOX;
            rect.BorderWidth = 1;
            rect.BorderColor = new BaseColor(clr);// BaseColor.RED;
            cb.Rectangle(rect);
            cb.Stroke();


            PdfRectAnnotation areaAnn = new PdfRectAnnotation(stamper.Writer);
            areaAnn.Rectangle = rect;
            areaAnn.Color = new BaseColor(clr);
            areaAnn.Put(PdfName.T, new PdfString(Convert.ToString((comments[0] as Hashtable)["authorName"]), PdfObject.TEXT_UNICODE));

            areaAnn.Contents = Convert.ToString((comments[0] as Hashtable)["content"]);
            areaAnn.Open = true;
            string mydate = Convert.ToString((comments[0] as Hashtable)["lastModified"]).Replace("GMT", "");
            areaAnn.DateTime = DateTime.ParseExact(mydate, "ddd MMM dd HH:mm:ss zzzz yyyy", null);

            stamper.AddAnnotation(areaAnn, pageno);
            AddComments(areaAnn, rect, comments, stamper, pageno);


        }

        private void AddHighlightAnnotation(Hashtable o, Hashtable comments, PdfStamper stamper, PdfReader reader)
        {

            int pageno = Convert.ToInt16(o["PageNo"]);

            iTextSharp.text.Rectangle PageSize = reader.GetPageSize(reader.GetPageNRelease(pageno));
            float W = PageSize.Width;
            float H = PageSize.Height;

            iTextSharp.text.Rectangle orgRect = new iTextSharp.text.Rectangle(float.Parse(o["x"].ToString()),
                                                                  float.Parse(o["y"].ToString()) + float.Parse(o["height"].ToString()),
                                                                  float.Parse(o["x"].ToString()) + float.Parse(o["width"].ToString()),
                                                                  float.Parse(o["y"].ToString()));
            iTextSharp.text.Rectangle rect = getBounds(stamper, pageno, W, H, orgRect);


            ArrayList rectangles = o["rectangles"] as ArrayList;


            var cb = stamper.GetOverContent(pageno);

            Color clr = Color.FromArgb(Convert.ToInt32(o["color"]));

            PdfArray quadPoints = new PdfArray();
            if (rectangles != null && rectangles.Count > 0)
            {
                PdfHighlightAnnotation highlightAnn = new PdfHighlightAnnotation(stamper.Writer);
                highlightAnn.Rectangle = rect;
                highlightAnn.Subject = Convert.ToString((comments[0] as Hashtable)["authorName"]);
                highlightAnn.Put(PdfName.T, new PdfString(Convert.ToString((comments[0] as Hashtable)["authorName"]), PdfObject.TEXT_UNICODE));
                highlightAnn.Contents = Convert.ToString((comments[0] as Hashtable)["content"]);
                highlightAnn.Open = true;
                highlightAnn.Color = new BaseColor(clr);


                foreach (Hashtable markup in rectangles)
                {

                    iTextSharp.text.Rectangle tRect = new iTextSharp.text.Rectangle(float.Parse(markup["x"].ToString()),
                                                       float.Parse(markup["y"].ToString()) + float.Parse(markup["height"].ToString()),
                                                       float.Parse(markup["x"].ToString()) + float.Parse(markup["width"].ToString()),
                                                       float.Parse(markup["y"].ToString()));

                    iTextSharp.text.Rectangle updatedRect = getBounds(stamper, pageno, W, H, tRect);

                    quadPoints.Add(new PdfNumber(updatedRect.GetLeft(0))); //0,0
                    quadPoints.Add(new PdfNumber(updatedRect.GetTop(0)));


                    quadPoints.Add(new PdfNumber(updatedRect.GetRight(0))); //1,0
                    quadPoints.Add(new PdfNumber(updatedRect.GetTop(0)));

                    quadPoints.Add(new PdfNumber(updatedRect.GetLeft(0))); //0,1
                    quadPoints.Add(new PdfNumber(updatedRect.GetBottom(0)));

                    quadPoints.Add(new PdfNumber(updatedRect.GetRight(0))); //1,1
                    quadPoints.Add(new PdfNumber(updatedRect.GetBottom(0)));

                }

                string mydate = Convert.ToString((comments[0] as Hashtable)["lastModified"]).Replace("GMT", "");
                highlightAnn.DateTime = DateTime.ParseExact(mydate, "ddd MMM dd HH:mm:ss zzzz yyyy", null);

                //highlightAnn.Flags = PdfAnnotation.FLAGS_READONLY;

                highlightAnn.Put(PdfName.QUADPOINTS, quadPoints);
                stamper.AddAnnotation(highlightAnn, pageno);
                AddComments(highlightAnn, rect, comments, stamper, pageno);
            }
        }

        private void AddStrikeoutAnnotation(Hashtable o, Hashtable comments, PdfStamper stamper, PdfReader reader)
        {
            int pageno = Convert.ToInt16(o["PageNo"]);

            iTextSharp.text.Rectangle PageSize = reader.GetPageSize(reader.GetPageNRelease(pageno));
            float W = PageSize.Width;
            float H = PageSize.Height;

            iTextSharp.text.Rectangle orgRect = new iTextSharp.text.Rectangle(float.Parse(o["x"].ToString()),
                                                                  float.Parse(o["y"].ToString()) + float.Parse(o["height"].ToString()),
                                                                  float.Parse(o["x"].ToString()) + float.Parse(o["width"].ToString()),
                                                                  float.Parse(o["y"].ToString()));
            iTextSharp.text.Rectangle rect = getBounds(stamper, pageno, W, H, orgRect);


            ArrayList rectangles = o["rectangles"] as ArrayList;


            var cb = stamper.GetOverContent(pageno);

            Color clr = Color.FromArgb(Convert.ToInt32(o["color"]));

            PdfArray quadPoints = new PdfArray();
            if (rectangles != null && rectangles.Count > 0)
            {
                PdfStrikeoutAnnotation strikeoutAnn = new PdfStrikeoutAnnotation(stamper.Writer);
                strikeoutAnn.Rectangle = rect;
                strikeoutAnn.Subject = Convert.ToString((comments[0] as Hashtable)["authorName"]);
                strikeoutAnn.Put(PdfName.T, new PdfString(Convert.ToString((comments[0] as Hashtable)["authorName"]), PdfObject.TEXT_UNICODE));
                strikeoutAnn.Contents = Convert.ToString((comments[0] as Hashtable)["content"]);
                strikeoutAnn.Open = true;
                strikeoutAnn.Color = new BaseColor(clr);


                foreach (Hashtable markup in rectangles)
                {

                    iTextSharp.text.Rectangle tRect = new iTextSharp.text.Rectangle(float.Parse(markup["x"].ToString()),
                                                       float.Parse(markup["y"].ToString()) + float.Parse(markup["height"].ToString()),
                                                       float.Parse(markup["x"].ToString()) + float.Parse(markup["width"].ToString()),
                                                       float.Parse(markup["y"].ToString()));

                    iTextSharp.text.Rectangle updatedRect = getBounds(stamper, pageno, W, H, tRect);


                    quadPoints.Add(new PdfNumber(updatedRect.GetLeft(0))); //0,0
                    quadPoints.Add(new PdfNumber(updatedRect.GetTop(0)));

                    quadPoints.Add(new PdfNumber(updatedRect.GetRight(0))); //1,0
                    quadPoints.Add(new PdfNumber(updatedRect.GetTop(0)));

                    quadPoints.Add(new PdfNumber(updatedRect.GetLeft(0))); //0,1
                    quadPoints.Add(new PdfNumber(updatedRect.GetBottom(0)));

                    quadPoints.Add(new PdfNumber(updatedRect.GetRight(0))); //1,1
                    quadPoints.Add(new PdfNumber(updatedRect.GetBottom(0)));
                }

                string mydate = Convert.ToString((comments[0] as Hashtable)["lastModified"]).Replace("GMT", "");
                strikeoutAnn.DateTime = DateTime.ParseExact(mydate, "ddd MMM dd HH:mm:ss zzzz yyyy", null);

                // strikeoutAnn.Flags = PdfAnnotation.FLAGS_READONLY;

                strikeoutAnn.Put(PdfName.QUADPOINTS, quadPoints);
                stamper.AddAnnotation(strikeoutAnn, pageno);
                AddComments(strikeoutAnn, rect, comments, stamper, pageno);
            }


            // CreateAnnotation(comment, BaseColor.RED, bounds, stamper, pageno);

        }

        #endregion

        #region Discussion Methods
        public String GetDiscussion(ulong DiscussionId, string sessionId, string language, string themename, string tenantName, string userId,List<string> reviewerList)
        {
            Topic               obj_TopicFacade                 = null;
            XML                 xml_TopicPostList               = null;
            ERRORXML            ErrorXML                        = null;
            XPathDocument       xpDoc_TopicPostList             = null;
            XPathNavigator      xpNav_TopicPostList             = null;
            XPathNodeIterator   xpNodItr_PostList               = null;
            XPathDocument       xpDoc                           = null;
            XPathNavigator      xpNav                           = null;
            String              str_FilePath                    = null;
            String              obj_Discussion                  = null;
            StringBuilder       sb_ErrorMessage                 = null;
            String              str_TopicXML                    = null;
            String              str_SourceFilePath              = null;
            StringBuilder       sb_SourceFilePath               = null;
            StringBuilder       sb_AssociationXML               = null;
            StringBuilder       sb_AttributesXML                = null;
            String              reviewerID                      = null;
            UserFacade          userFacadeObj                   = null;            
            String              TopicTitle                      = null;
            PMFacadeClass       PMFacadeObj                     = null;
            String              ProcessID                       = null;
            String              TopicDescription                = null;
            String[]            TopicDescriptionArr             = null;
            String              str_ProcessXML                  = null;
            String              ColorCode                       = null; 
            Boolean             UpdateTopicRequired             = false;
            Boolean             ShowAllReviewersComments        = false;
            String              MediaFileURL                    = null;
            String              MediaFileDisplayName            = null; 
            List<String>        NonReviewerList                 = new List<string>();
            String              ContributorListStr              = ""; //used for removing duplicate users
			UTF8Encoding		encode							= null;

            SessionID       = sessionId;
            Language        = language;
            TenantName      = tenantName;
            UserID          = userId;

            if (reviewerList.Count == 0)
                ShowAllReviewersComments = true;

            try
            {
                m_DiscussionID      = DiscussionId.ToString();
                obj_TopicFacade     = new Topic(SessionID, UserID, TenantName, Language);                
                sb_ErrorMessage     = new StringBuilder(100);                
                
                ErrorXML = obj_TopicFacade.GetTopic(m_DiscussionID, null, null, ref str_TopicXML);
                if (String.IsNullOrEmpty(ErrorXML))
                {
                    xpDoc                   = new XPathDocument(new StringReader(str_TopicXML));
                    xpNav                   = xpDoc.CreateNavigator();
                    
                    ErrorXML                = GetSourceFile(xpNav.SelectSingleNode("TOPIC/FILESYSTEM/BINDER/FILE"), out str_SourceFilePath);
                    MediaFileDisplayName    = xpNav.SelectSingleNode("TOPIC/FILESYSTEM/BINDER/FILE/DISPLAYNAME").Value;
					ALSolutionCommon.EncodeSpecialCharacters(ref MediaFileDisplayName);
					encode = new UTF8Encoding();
					MediaFileDisplayName = Convert.ToBase64String(encode.GetBytes(MediaFileDisplayName));
                    sb_SourceFilePath       = new StringBuilder(100);
                    sb_SourceFilePath.AppendFormat("{0}{1}", ALSolutionCommon.GetHTTPDownloadFilePath(TenantName), System.Web.HttpUtility.UrlEncode(str_SourceFilePath.Substring(str_SourceFilePath.LastIndexOf("\\") + 1)));
                    TopicDescription = xpNav.SelectSingleNode("TOPIC/TOPICDESCRIPTION").Value;
                    TopicDescriptionArr = TopicDescription.Split(new String[] { "$AL$" }, StringSplitOptions.None);                    
                }

                #region Add Reviewers Details
                sb_AssociationXML = new StringBuilder();
                sb_AssociationXML.Append(@"<ASSOCIATION>                                        
                                        <PROCESS_ACTIVITY Type='RELATION'>
                                            <ACTIVITY_CONTRIBUTOR Type='RELATION'>
                                                <USERID/>
                                                <LOGINNAME/>
                                                <FIRSTNAME/>
                                                <LASTNAME/>
                                            </ACTIVITY_CONTRIBUTOR>
                                        </PROCESS_ACTIVITY>
                                    </ASSOCIATION>");

                sb_AttributesXML = new StringBuilder();
                sb_AttributesXML.Append(@"<WORKFLOWPROCESS>
	                                    <WORKFLOWPROCESSID/>
                                    </WORKFLOWPROCESS>");

                TopicTitle = xpNav.SelectSingleNode("TOPIC/TOPICTITLE").Value;
                if (!String.IsNullOrEmpty(TopicTitle))
                {
                    String[] TempArr = TopicTitle.Split(new String[] { "_" }, StringSplitOptions.None);
                    ProcessID = TempArr[1];
                    PMFacadeObj = new PMFacadeClass(SessionID, UserID, TenantName, Language);
                    ErrorXML = PMFacadeObj.GetProcess(ProcessID, sb_AssociationXML.ToString(), sb_AttributesXML.ToString(), out str_ProcessXML);
                }

                userFacadeObj = GetUserFacadeObj(themename);

                if (String.IsNullOrEmpty(ErrorXML))
                {
                    xpDoc = new XPathDocument(new StringReader(str_ProcessXML));
                    xpNav = xpDoc.CreateNavigator();                    
                    XPathNodeIterator ContributorList = xpNav.Select(@"WORKFLOWPROCESS/PROCESS_ACTIVITY/ACTIVITY
                                [(STARTACTIVITY[translate(text(),'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ') = 'FALSE']) 
                                and (ENDACTIVITY[translate(text(),'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ') = 'FALSE']) 
            and (STATUS[translate(text(),'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ') != 'CANCELLED'])]/ACTIVITY_CONTRIBUTOR/USER");                                    
                    XPathNavigator xpNav_User = null;
                    String ContributorID = null;
                    int counter = 0;
                    MediaFileURL = sb_SourceFilePath.ToString();                    
                                        
                    ALSolutionCommon.EncodeSpecialCharacters(ref MediaFileURL);
                    obj_Discussion = "<DISCUSSION path='" + MediaFileURL + "' displayname='" + MediaFileDisplayName + "'>";
                    obj_Discussion += "<REVIEWERS>";
                    if (ContributorList != null)
                    {
                        String[] ColorCodeList = null;
                        String ColorCodeUserIDList = null;
                        Hashtable ColorCodesHashed = new Hashtable();
                        String[] tempColorArr = null;
                        Boolean ContributorDeleted = false;

                        if (TopicDescriptionArr != null && TopicDescriptionArr.Length > 1 && !String.IsNullOrEmpty(TopicDescriptionArr[1]))
                        {
                            ColorCodeList = TopicDescriptionArr[1].Split(new Char[] { ';' });
                            counter = ColorCodeList.Length;
                            foreach (string colorConfig in ColorCodeList)
                            {
                                tempColorArr = colorConfig.Split(new Char[] { ':' });
                                if (ColorCodesHashed[tempColorArr[0]] == null) //Check added to handle error when same user is added twice: bug 9376
                                    ColorCodesHashed.Add(tempColorArr[0], tempColorArr[1]);
                                ColorCodeUserIDList += " " + tempColorArr[0] + ",";
                            }

                            if (ContributorList.Count != counter)
                            {
                                ContributorDeleted = true;
                                UpdateTopicRequired = true;
                                TopicDescriptionArr[1] = "$AL$";
                            }
                            else
                            {
                                XPathNodeIterator tempContributorList = ContributorList.Clone();
                                while (tempContributorList.MoveNext())
                                {
                                    String tempContributorID = tempContributorList.Current.SelectSingleNode("USERID").Value;
                                    if (!ColorCodeUserIDList.Contains(" " + tempContributorID))
                                    {
                                        ContributorDeleted = true;
                                        UpdateTopicRequired = true;
                                        TopicDescriptionArr[1] = "$AL$";
                                        break;
                                    }
                                }
                            }
                        }
                        else
                            TopicDescriptionArr = new String[2] {TopicDescriptionArr[0], "$AL$"};                            

                        while (ContributorList.MoveNext())
                        {
                            xpNav_User = ContributorList.Current;
                            if (xpNav_User != null)
                            {
                                ContributorID = xpNav_User.SelectSingleNode("USERID").Value;
                                if (ContributorListStr.IndexOf(" " + ContributorID + ",") < 0) //Check to avoid adding duplicate users: Bug 9376
                                {
                                    ContributorListStr += " " + ContributorID + ",";
                                    if (ColorCodesHashed[" " + ContributorID] != null)
                                    {
                                        ColorCode = ColorCodesHashed[" " + ContributorID].ToString();
                                        if (ContributorDeleted)
                                            TopicDescriptionArr[1] += " " + ContributorID + ":" + ColorCode + ";";
                                    }
                                    else
                                    {
                                        if (!UpdateTopicRequired)
                                            UpdateTopicRequired = true;

                                        if (colorList == null)
                                            LoadColorList();

                                        ColorCode = colorList[counter];
                                        TopicDescriptionArr[1] += " " + ContributorID + ":" + ColorCode + ";";
                                        counter++;
                                    }

                                    obj_Discussion += GetUserDetailsXML(ContributorID, xpNav_User, ColorCode, userFacadeObj, "REVIEWER", true);
                                    if (ShowAllReviewersComments)
                                        reviewerList.Add(ContributorID);
                                }
                            }
                        }
                    }
                    obj_Discussion += "</REVIEWERS>";
                }
                #endregion

                ErrorXML = obj_TopicFacade.GetPostList(DiscussionId, out xml_TopicPostList);
                if (String.IsNullOrEmpty(ErrorXML))
                {
                    xpDoc_TopicPostList = new XPathDocument(new StringReader(xml_TopicPostList));
                    xpNav_TopicPostList = xpDoc_TopicPostList.CreateNavigator();
                    xpNodItr_PostList   = xpNav_TopicPostList.Select("TOPICCOLLECTION/TOPIC/TOPICPOST/POST");
                    obj_Discussion += "<POSTLIST>";                    
                    foreach (XPathNavigator xpNav_Post in xpNodItr_PostList)
                    {
                        reviewerID = xpNav_Post.SelectSingleNode("POSTOWNER/USER/USERID").Value;
                        ErrorXML = GetFile(xpNav_Post, AttachementType.Comments, out str_FilePath);
                        if (String.IsNullOrEmpty(ErrorXML) && File.Exists(str_FilePath))
                        {
                            if (ShowAllReviewersComments)
                            {
                                obj_Discussion += File.ReadAllText(str_FilePath);                                
                                if (!reviewerList.Contains(reviewerID))
                                    NonReviewerList.Add(reviewerID);
                            }
                            else
                            {
                                if (reviewerList.Count > 0 && reviewerList.Contains(reviewerID))
                                    obj_Discussion += File.ReadAllText(str_FilePath);
                            }
                        }
                    }
                    obj_Discussion += "</POSTLIST>";

                    #region Add NonReviewer Details          
                    if (NonReviewerList.Count > 0)
                        obj_Discussion += GetNonReviewerDetailsXML(NonReviewerList, themename, userFacadeObj);
                    #endregion

                    obj_Discussion += "</DISCUSSION>";
                }

                if (UpdateTopicRequired)
                {
                    TopicDescriptionArr[1] = TopicDescriptionArr[1].Substring(0, TopicDescriptionArr[1].Length - 1);                    
                    TopicDescription = TopicDescriptionArr[0] + TopicDescriptionArr[1];
                    String updateXML = "<TOPIC><TOPICID>"+m_DiscussionID+"</TOPICID><TOPICDESCRIPTION>"+ TopicDescription +"</TOPICDESCRIPTION></TOPIC>";
                    ErrorXML = obj_TopicFacade.UpdateTopic(ref updateXML);
                }
            }
            catch(Exception ex)
            {
                throw ex;
                 //sb_ErrorMessage.AppendFormat("{0}: {1}",Localization.GetString("ALErrorResource", TenantName, "EXCEPTION_shared"),obj_Exception.Message);

            }
            return obj_Discussion;
        }

        public ArrayCollection GetImageTiles(string filename, string TenantName)
        {
            string imagePath = ALSolutionCommon.GetDownloadFilePath(TenantName) + filename;

            ArrayCollection returnData = new ArrayCollection();

            ArrayCollection dimensions = new ArrayCollection();


            ArrayCollection rows = new ArrayCollection();

            returnData.Add(dimensions);
            returnData.Add(rows);


            int frameW = 500;
            int frameH = 500;
            // Create image.



            /*   Bitmap frame = new Bitmap(orgWidth,
                   orgHeight,
                   PixelFormat.Format24bppRgb);
               frame.SetResolution(96, 96);

               Graphics grPhoto = Graphics.FromImage(frame);
               grPhoto.Clear(Color.Black);
               grPhoto.InterpolationMode =
                   InterpolationMode.HighQualityBicubic;

               grPhoto.CompositingQuality = CompositingQuality.HighQuality;

               grPhoto.SmoothingMode = SmoothingMode.HighQuality;

               grPhoto.DrawImage(newImage,
                   new System.Drawing.Rectangle(0, 0, orgWidth, orgHeight),
                   new System.Drawing.Rectangle(0, 0, orgWidth, orgHeight),
                   GraphicsUnit.Pixel);

               frame.Save(@"C:\D\MediaApprovals\new1.jpg", ImageFormat.Jpeg);
            */
            using (System.Drawing.Image newImage = System.Drawing.Image.FromFile(imagePath))
            {


                int orgWidth = newImage.Width;
                int orgHeight = newImage.Height;

                dimensions.Add(orgWidth);
                dimensions.Add(orgHeight);

                dimensions.Add(frameW);
                dimensions.Add(frameH);


                int colCount = orgWidth / frameW + 1;
                int rowCount = orgHeight / frameH + 1;

                for (int irow = 0; irow < rowCount; irow++)
                {
                    //      int irow = 0;

                    ArrayCollection cols = new ArrayCollection();

                    for (int icol = 0; icol < colCount; icol++)
                    {

                        frameW = 500;
                        frameH = 500;
                        int frameSize = frameW;

                        if (icol == colCount - 1)
                        {
                            int pendingW = orgWidth - (icol) * frameW;

                            if (pendingW > 0)
                            {
                                frameW = pendingW;
                            }
                            else
                            {
                                continue;
                            }
                        }

                        if (irow == rowCount - 1)
                        {
                            int pendingH = orgHeight - (irow) * frameH;

                            if (pendingH > 0)
                            {
                                frameH = pendingH;
                            }
                            else
                            {
                                continue;
                            }
                        }

                        Bitmap bmpDst = new Bitmap(frameW, frameH);
                        bmpDst.SetResolution(newImage.HorizontalResolution, newImage.VerticalResolution);

                        using (Graphics gfx = Graphics.FromImage(bmpDst))
                        {
                            System.Drawing.Rectangle cliprect = new System.Drawing.Rectangle(icol * frameSize, irow * frameSize, frameW, frameH);
                            gfx.DrawImage(newImage, 0, 0, cliprect, GraphicsUnit.Pixel);
                        }

                        MemoryStream stream = new MemoryStream();

                        bmpDst.Save(stream, ImageFormat.Jpeg);
                        byte[] mybytes = stream.ToArray();
                        ByteArray bytes = new ByteArray();
                        bytes.WriteBytes(mybytes, 0, mybytes.Length);

                        cols.Add(bytes);

                    }
                    rows.Add(cols);
                }
            }

            return returnData;

        }
        #endregion
        
        #region Private Methods        
        
        private UserFacade GetUserFacadeObj(String themename)
        {
            UserFacade userFacadeObj = null;
            
            if (!String.IsNullOrEmpty(themename))
                userFacadeObj = new UserFacade(SessionID, UserID, TenantName, Language, "", themename);
            else
                userFacadeObj = new UserFacade(SessionID, UserID, TenantName, Language);
            
            return userFacadeObj;
        }

        private String ConvertListToCommaSeperatedString(List<String> lst)
        {
            String result = "";
            foreach (String item in lst)
                 result += item + ",";

            if (!String.IsNullOrEmpty(result))
                result = result.Substring(0, result.Length - 1);

            return result;
        }

        private String GetNonReviewerDetailsXML(List<String> NonReviewerList, String themename, UserFacade userFacadeObj)
        {   
            XPathDocument xpDoc_UserColl        = null;
            XPathNavigator xpNav_UserColl       = null;
            XPathNodeIterator xpNodeItr_Users   = null;
            XPathNavigator xpNav_User           = null;
            String userDetailsXML               = null;
            String NonReviewerID                = null;
            String ErrorXML                     = null;
            SearchConfiguration searchObj       = new SearchConfiguration(SessionID, UserID, TenantName, Language);
            String NonReviewerDetailsXML        = "<NONREVIEWERS>";
            StringBuilder SearchBuilder         = new StringBuilder(100);

            SearchBuilder.Append(@"<SEARCH>
                                <SESSIONINFO UserID='" + UserID.ToString() + "' TenantName='" + TenantName + "' Language='" + Language + "' SessionID='" + SessionID + @"'/>
                                <TARGETOBJECT>USER</TARGETOBJECT>
                                <TARGETOBJECTTYPE>ENTITY</TARGETOBJECTTYPE>
                                <SEARCHALLFACETS>FALSE</SEARCHALLFACETS>
                                <AUTHORIZATIONREQUIRED>FALSE</AUTHORIZATIONREQUIRED>
                                <TARGETENTITY>
                                    <PRIVILEGENAME>READ</PRIVILEGENAME>	                                                    
                                    <SELECTLIST>
                                        <EXPRESSION>
                                            <FIELDNAME>TOPICID</FIELDNAME>
                                            <ALIAS>TOPICID</ALIAS>
                                        </EXPRESSION>
                                        <EXPRESSION>
                                            <FIELDNAME>FIRSTNAME</FIELDNAME>
                                            <ALIAS>FIRSTNAME</ALIAS>
                                        </EXPRESSION>
                                        <EXPRESSION>
                                            <FIELDNAME>LASTNAME</FIELDNAME>
                                            <ALIAS>LASTNAME</ALIAS>
                                        </EXPRESSION>
                                        <EXPRESSION>
                                            <FIELDNAME>LOGINNAME</FIELDNAME>
                                            <ALIAS>LOGINNAME</ALIAS>
                                        </EXPRESSION>                                                    		                                                                                                        		                                                    
                                    </SELECTLIST>                                   	                                                    		                                                    
                                    <FILTERLIST>		                                        
                                        <FILTER>
                                            <FILTERID>1</FILTERID>
                                            <EXPRESSION>USERID</EXPRESSION>
                                            <OPERATOR>IN</OPERATOR>
                                            <EXPRESSIONVALUE>(" + ConvertListToCommaSeperatedString(NonReviewerList) + @")</EXPRESSIONVALUE>
                                            <ISCASESENSITIVE>False</ISCASESENSITIVE>                                                    
                                        </FILTER>
                                    </FILTERLIST>
                                </TARGETENTITY>
                            </SEARCH>");
                        
            ErrorXML = searchObj.GetHierarchialData(SearchBuilder.ToString(), ref userDetailsXML);

            xpDoc_UserColl  = new XPathDocument(new StringReader(userDetailsXML));
            xpNav_UserColl  = xpDoc_UserColl.CreateNavigator();
            xpNodeItr_Users = xpNav_UserColl.Select("USERCOLLECTION/USER");

            while (xpNodeItr_Users.MoveNext())
            {
                xpNav_User              = xpNodeItr_Users.Current;
                NonReviewerID           = xpNav_User.SelectSingleNode("USERID").Value;                
                NonReviewerDetailsXML   += GetUserDetailsXML(NonReviewerID, xpNav_User, DEFAULT_NONREVIEWER_COLOR, userFacadeObj, "NONREVIEWER", false);
            }

            NonReviewerDetailsXML += "</NONREVIEWERS>";

            return NonReviewerDetailsXML;
        }

        private String GetUserDetailsXML(String ContributorID, XPathNavigator xpNav_User, String ColorCode, UserFacade userFacadeObj, String NodeName, Boolean ProfilePictureRequired)
        {
            String reviewerName = xpNav_User.SelectSingleNode("FIRSTNAME").Value;
            String userThumbnail = null;
            if (String.IsNullOrEmpty(reviewerName))
                reviewerName = xpNav_User.SelectSingleNode("LASTNAME").Value;
            else
            {
                String lastName = xpNav_User.SelectSingleNode("LASTNAME").Value;
                if (!String.IsNullOrEmpty(lastName))
                    reviewerName += " " + lastName;
            }

            if (String.IsNullOrEmpty(reviewerName))
                reviewerName = xpNav_User.SelectSingleNode("LOGINNAME").Value;

            if (ProfilePictureRequired)
            {
                userThumbnail = userFacadeObj.GetUserProfilePictureThumbnailPath(ContributorID);
                ALSolutionCommon.EncodeSpecialCharacters(ref userThumbnail);
                return "<" + NodeName + " id='" + ContributorID + "' name='" + ALSpecialCharHandling.TrimAndReplaceSpecialChars(reviewerName) + "' path='" + userThumbnail + "' color='" + ColorCode + "'/>";
            }
            else
                return "<" + NodeName + " id='" + ContributorID + "' name='" + ALSpecialCharHandling.TrimAndReplaceSpecialChars(reviewerName) + "' color='" + ColorCode + "'/>";
        }

        ERRORXML LoadColorList()
        {
            XPathDocument xpDoc_ColorList       = null;
            XPathNavigator xpNav_ColorList      = null;
            XPathNavigator xpNav_Color          = null;
            XPathNodeIterator xpNodeItr_Colors  = null;
            int Counter                         = 0;

            String str_ColorListXMLPath = ALSolutionCommon.GetConfigurationXMLPath(TenantName, "Common", "", "ReviewerColorListConfig");
            xpDoc_ColorList             = new XPathDocument(str_ColorListXMLPath);
            xpNav_ColorList             = xpDoc_ColorList.CreateNavigator();
            xpNodeItr_Colors            = xpNav_ColorList.Select("ColorList/Color");

            colorList = new String[xpNodeItr_Colors.Count];

            while (xpNodeItr_Colors.MoveNext())
            {
                xpNav_Color         = xpNodeItr_Colors.Current;
                colorList[Counter]  = xpNav_Color.GetAttribute("value", "");
                Counter++;
            }
            
            return null;
        }

        ERRORXML GetFile(XPathNavigator xpNav_Post, AttachementType attachementType, out String str_FilePath)
        {
            ERRORXML            ErrorXML            = null;
            StringBuilder       sb_FileXML          = null;
            String              str_ObjectID        = null;
            String              str_FieldName       = null;
            String              str_SchemaID        = null;
            String              str_FileName        = null;
            XPathNavigator      xpNav_FileSystem    = null;
            String              str_Xpath           = null;
            String              str_ErrorMessage    = null;
            Boolean           OverWriteExistingFile = true;
                                str_FilePath        = String.Empty;
                                sb_FileXML          = new StringBuilder(100);
            try
            {

                switch (attachementType)
                {
                    case AttachementType.Comments:
                        {
                            str_Xpath               = "FILESYSTEM/BINDER/FILE/NAME[text()='comments.xml']";
                        } break;
                    case AttachementType.Background:
                        {
                            str_Xpath               = "FILESYSTEM/BINDER/FILE/NAME[text()='Background.png']";
                        } break;
                    case AttachementType.Thumbnail:
                        {
                            str_Xpath               = "FILESYSTEM/BINDER/FILE/NAME[text()='Thumbnail.png']";
                        } break;
                }
                xpNav_FileSystem = xpNav_Post.SelectSingleNode(str_Xpath);

                if (xpNav_FileSystem != null)
                {
                    xpNav_FileSystem.MoveToParent();
                    str_ObjectID    = xpNav_FileSystem.SelectSingleNode("OBJECTID").Value;
                    str_FieldName   = xpNav_FileSystem.SelectSingleNode("FIELDNAME").Value;
                    str_SchemaID    = xpNav_FileSystem.SelectSingleNode("SCHEMAID").Value;
                    str_FileName    = xpNav_FileSystem.SelectSingleNode("NAME").Value;
                }
                else
                {
                    str_ErrorMessage = Localization.GetString("ALErrorResource", TenantName, "ERR_GETFILE_FAILED_shared");
                    return str_ErrorMessage;
                }

                ErrorXML =  GetFile(str_ObjectID, str_FieldName, str_SchemaID, str_FileName,OverWriteExistingFile, out str_FilePath);
                if (ErrorXML != null)
                {
                    str_ErrorMessage = Localization.GetString("ALErrorResource", TenantName, "ERR_GETFILE_FAILED_shared");
                    return str_ErrorMessage;
                }
                return ErrorXML;
            }
            catch (Exception obj_Exception)
            {
                return obj_Exception.Message;
            }
        }

        ERRORXML GetFile(String str_ObjectID, String str_FieldName, String str_SchemaID, String str_FileName,Boolean OverWriteExisitingFile, out String str_FilePath)
        {
            ERRORXML            ErrorXML                = null;
            StringBuilder       sb_FileXML              = null;
            StringBuilder       sb_FilePath             = null;
             StringBuilder      sb_CopyFilePath         = null;
            String              str_FileXML             = null;
            String              str_ErrorMessage        = null;
            String              FilePathOnServer        = null;
            StringBuilder       sb_DownloadFileName     = null;
            XPathDocument       xpDoc_FileSystem        = null;
            XPathNavigator      xpNav_FileSystem        = null;
            str_FilePath        = String.Empty;
            sb_FileXML          = new StringBuilder(100);
            try
            {   
                #region Check file is present in DownloadFiles
                obj_FileTransfer        = new FileTransfer(SessionID, UserID, TenantName, Language);
                sb_FilePath             = new StringBuilder(100);
                sb_DownloadFileName     = new StringBuilder(100);

                sb_DownloadFileName.AppendFormat("{0}_{1}_{2}", str_ObjectID, SessionID, str_FileName);
                if (!OverWriteExisitingFile)
                {
                    sb_FilePath.AppendFormat("{0}{1}", ALSolutionCommon.GetDownloadFilePath(TenantName), sb_DownloadFileName.ToString());
                    if (File.Exists(sb_FilePath.ToString()))
                    {
                        str_FilePath = sb_FilePath.ToString();
                        return null;
                    }
                    else
                    {
                        sb_DownloadFileName.Remove(0, sb_DownloadFileName.Length);
                        sb_FilePath.Remove(0, sb_FilePath.Length);
                        sb_DownloadFileName.AppendFormat("{0}_{1}", str_ObjectID, str_FileName);
                        sb_FilePath.AppendFormat("{0}{1}", ALSolutionCommon.GetDownloadFilePath(TenantName), sb_DownloadFileName.ToString());
                        if (File.Exists(sb_FilePath.ToString()))
                        {
                            sb_CopyFilePath = new StringBuilder(100);
                            sb_CopyFilePath.AppendFormat("{0}{1}_{2}_{3}", ALSolutionCommon.GetDownloadFilePath(TenantName), str_ObjectID, SessionID, str_FileName);
                            File.Copy(sb_FilePath.ToString(), sb_CopyFilePath.ToString());
                            str_FilePath = sb_CopyFilePath.ToString();
                            return null;
                        }
                    }
                }
                #endregion
                #region Get File in OutBox
                sb_FileXML.AppendFormat("<FILESYSTEM ObjectID='{0}'>", str_ObjectID);
                sb_FileXML.AppendFormat("<FILE FileRequired='YES'>");
                sb_FileXML.AppendFormat("<FIELDNAME>{0}</FIELDNAME>", str_FieldName);
                sb_FileXML.AppendFormat("<OBJECTID>{0}</OBJECTID>", str_ObjectID);
                sb_FileXML.AppendFormat("<SCHEMAID>{0}</SCHEMAID>", str_SchemaID);
                ALSolutionCommon.EncodeSpecialCharacters(ref str_FileName);
                sb_FileXML.AppendFormat("<NAME>{0}</NAME>", str_FileName);
                sb_FileXML.AppendFormat("</FILE>");
                sb_FileXML.AppendFormat("</FILESYSTEM>");
                str_FileXML = sb_FileXML.ToString();

                //Retreiving the files from the OM Reporsitory
                obj_FileFacade = new FileFacade(SessionID, UserID, TenantName, Language);
                ErrorXML       = obj_FileFacade.GetFile(ref str_FileXML);
                if (ErrorXML != null)
                {
                    str_ErrorMessage = Localization.GetString("ALErrorResource", TenantName, "ERR_GETFILE_FAILED_shared");
                    return str_ErrorMessage;
                }
                #endregion

                #region Get File on IIS
                xpDoc_FileSystem = new XPathDocument(new StringReader(str_FileXML));
                xpNav_FileSystem = xpDoc_FileSystem.CreateNavigator();
                FilePathOnServer = xpNav_FileSystem.SelectSingleNode("FILESYSTEM/FILE/PATH").Value;
                FilePathOnServer = ALSolutionCommon.TrimAndReplaceSpecialChars(FilePathOnServer);
                sb_FileXML = new StringBuilder(100);
                sb_FileXML.AppendFormat("<FILESYSTEM><FILE FileRequired='YES'><SOURCEPATH>{0}</SOURCEPATH></FILE></FILESYSTEM>", FilePathOnServer);
                sb_FileXML.Replace("''", "'");
                str_FileXML = sb_FileXML.ToString();
                //Retrieving the files from the Service machine
                //Check for media streaming
                
                obj_FileTransfer.GetFilePath = ALSolutionCommon.GetDownloadFilePath(TenantName);
                obj_FileTransfer.DownloadFileName = sb_DownloadFileName.ToString();
                ErrorXML = obj_FileTransfer.GetFile(ref str_FileXML);
                if (ErrorXML != null)
                {
                    str_ErrorMessage = Localization.GetString("ALErrorResource", TenantName, "ERR_GETFILE_FAILED_shared");
                    return str_ErrorMessage;
                }
                str_FilePath = obj_FileTransfer.GetFilePath + sb_DownloadFileName.ToString();
                #endregion
            }
            catch (Exception obj_Exception)
            {
                return obj_Exception.Message;
            }
            return ErrorXML;
        }

        private void CreateFileNode(XmlDocument xmlDoc_Post, XmlElement xmlEle_Binder, String str_FileName, String str_FilePath, String str_Order)
        {
            XmlElement xmlEle_File  = null;
            XmlElement xmlEle_Field = null;

            xmlEle_File             = xmlDoc_Post.CreateElement("FILE");
            xmlEle_File.SetAttribute("Operation", "Create");
            xmlEle_File.SetAttribute("Order", str_Order);
            xmlEle_Binder.AppendChild(xmlEle_File);

            xmlEle_Field            = xmlDoc_Post.CreateElement("FIELDNAME");
            xmlEle_Field.InnerText  = AttachmentFieldName;
            xmlEle_File.AppendChild(xmlEle_Field);

            xmlEle_Field            = xmlDoc_Post.CreateElement("DISPLAYNAME");
            xmlEle_Field.InnerText  = str_FileName;
            xmlEle_File.AppendChild(xmlEle_Field);

            xmlEle_Field            = xmlDoc_Post.CreateElement("NAME");
            xmlEle_Field.InnerText  = str_FileName;
            xmlEle_File.AppendChild(xmlEle_Field);

            xmlEle_Field            = xmlDoc_Post.CreateElement("PATH");
            xmlEle_Field.InnerText  = str_FilePath;
            xmlEle_File.AppendChild(xmlEle_Field);
        }

        void SetBackgroundParameters(XPathNavigator xpNav_Post, Comment obj_Comment)
        {
            XPathNavigator xpNav_FileSystem = null;
            xpNav_FileSystem = xpNav_Post.SelectSingleNode("FILESYSTEM/BINDER/FILE/NAME[text()='comments.xml']");

            if (xpNav_FileSystem != null)
            {
                xpNav_FileSystem.MoveToParent();
                obj_Comment.Background_ObjectID     = xpNav_FileSystem.SelectSingleNode("OBJECTID").Value;
                obj_Comment.Background_SchemaID     = xpNav_FileSystem.SelectSingleNode("SCHEMAID").Value;
                obj_Comment.Background_FileID       = xpNav_FileSystem.SelectSingleNode("FILEID").Value;
            }
        }

        ERRORXML GetApprovalDocument(XPathNavigator xpNav_Topic, out String SourcePath)
        {


            XPathNavigator xpNav_File = null;
            String str_ObjectID = null;
            String str_FieldName = null;
            String str_SchemaID = null;
            String str_FileName = null;
            ERRORXML ErrorXML = null;
            SourcePath = String.Empty;
            try
            {
                xpNav_File = xpNav_Topic.SelectSingleNode("TOPIC/FILESYSTEM/BINDER/FILE");
                str_ObjectID = xpNav_File.SelectSingleNode("OBJECTID").Value;
                str_FieldName = xpNav_File.SelectSingleNode("FIELDNAME").Value;
                str_FileName = xpNav_File.SelectSingleNode("NAME").Value;
                str_SchemaID = xpNav_File.SelectSingleNode("SCHEMAID").Value;

                ErrorXML = GetFile(str_ObjectID, str_FieldName, str_SchemaID, str_FileName,false, out SourcePath);

            }
            catch (Exception obj_Exception)
            {
                string message = obj_Exception.Message;

            }
            return ErrorXML;
        }

        ERRORXML GetSourceFile(XPathNavigator xpNav_File, out String SourcePath)
        {   
            String str_ObjectID = null;
            String str_FieldName = null;
            String str_SchemaID = null;
            String str_FileName = null;
            ERRORXML ErrorXML = null;
            SourcePath = String.Empty;
            try
            {   
                str_ObjectID = xpNav_File.SelectSingleNode("OBJECTID").Value;
                str_FieldName = xpNav_File.SelectSingleNode("FIELDNAME").Value;
                str_FileName = xpNav_File.SelectSingleNode("NAME").Value;
                str_SchemaID = xpNav_File.SelectSingleNode("SCHEMAID").Value;

                ErrorXML = GetFile(str_ObjectID, str_FieldName, str_SchemaID, str_FileName,false, out SourcePath);

            }
            catch (Exception obj_Exception)
            {
                string message = obj_Exception.Message;

            }
            return ErrorXML;
        }
        #endregion
       
    }
}
