using System;
using System.Collections.Generic;
using FluorineFx;
using FluorineFx.AMF3;
using System.IO;
using System.Xml.Serialization;
using System.Text;
using System.Xml;
using System.Xml.XPath;
using Assetlink.Solutions.Facade.MessageBoardFacade;
using Assetlink;
using Assetlink.Solutions;
using Assetlink.Solutions.Facade.CommonFacade;
using Assetlink.IOProxy;
namespace ALVisualAnnotation
{
    using XML       = System.String;
    using ERRORXML  = System.String;

    [RemotingService]
    public class Service
    {

        #region Member Variables

        const String AttachmentFieldName    = "POSTATTACHMENTS";

        Post            obj_PostFacade      = null;
        FileFacade      obj_FileFacade      = null;
        FileTransfer    obj_FileTransfer    = null;
        
        
        enum AttachementType
        {
            Comments,
            Thumbnail,
            Background
        };

        #endregion

        #region Properties
        private String m_SessionID = null;
        public String SessionID
        {
            get { return m_SessionID; }
            set { m_SessionID = value; }
        }

        private String m_UserID = null;
        public String UserID
        {
            get { return m_UserID; }
            set { m_UserID = value; }
        }

        private String m_TenantName = null;
        public String TenantName
        {
            get { return m_TenantName; }
            set { m_TenantName = value; }

        }

        private String m_Language;
        public String Language
        {
            get { return m_Language; }
            set { m_Language = value; }
        }
        #endregion

        public void SaveThumbnail(string bitmapString)
        {
        }

        #region Old Code
        /*
        public void AddComment(Comment commentObj)
        {
            StringWriter writer = new StringWriter();
            XmlSerializer serializer = new XmlSerializer(typeof(Comment));
            serializer.Serialize(writer, commentObj);
            //return writer.ToString();


            FileStream fs = new FileStream(@"C:\Assetlink\Annotaion Feature\WebSite\mudis.xml", FileMode.CreateNew);
            System.Text.ASCIIEncoding encoding = new System.Text.ASCIIEncoding();
            byte[] encodedDataAsBytes = encoding.GetBytes(writer.ToString());
          //  byte[] encodedDataAsBytes = commentObj.ToString().ToCharArray();//System.Convert.FromBase64String(commentObj.ToString().t);
            fs.Write(encodedDataAsBytes, 0, encodedDataAsBytes.Length);
            
            fs.Close();

            FileStream fs1 = new FileStream(@"C:\Assetlink\Annotaion Feature\WebSite\mudis.png", FileMode.CreateNew);
            byte[] encodedDataAsBytes1 = System.Convert.FromBase64String(commentObj.Background);
            fs1.Write(encodedDataAsBytes1, 0, encodedDataAsBytes1.Length);
            fs1.Close();


            FileStream fs2 = new FileStream(@"C:\Assetlink\Annotaion Feature\WebSite\mudisThumb.png", FileMode.CreateNew);
            byte[] encodedDataAsBytes2 = System.Convert.FromBase64String(commentObj.Thumbnail);
            fs2.Write(encodedDataAsBytes2, 0, encodedDataAsBytes2.Length);
            fs2.Close();
        }

        public Comment GetComment()
        {
            Comment comObj = null;
            XmlSerializer s = new XmlSerializer(typeof(Comment));
            TextReader r = new StreamReader(@"C:\Assetlink\Annotaion Feature\WebSite\mudis.xml");
            comObj = (Comment)s.Deserialize(r);
            r.Close();
            return comObj;
        }

        public Discussion GetDiscussion(int discussionId)
        {
            Discussion discussion = new Discussion();

           

            string[] arr= new string[]{"1","20","35","50"};

            for (int i = 0; i < 4; i++)
            {
                XmlSerializer s = new XmlSerializer(typeof(Comment));
                TextReader r = new StreamReader(@"C:\Assetlink\Annotaion Feature\WebSite\mudis.xml");
                Comment commObj = (Comment)s.Deserialize(r);
                commObj.AddedAt = arr[i];
                discussion.CommentList.Add(commObj);
                r.Close();
            }

            return discussion;

        }

        public string GetCommentBackground(String Background_SchemaID, String Background_ObjectID)
        {
            StreamReader sr = new StreamReader(@"C:\Assetlink\Annotaion Feature\WebSite\a.png");
            string s = sr.ReadToEnd();
            sr.Close();

            System.Text.ASCIIEncoding encoding = new System.Text.ASCIIEncoding();


            return s;// System.Convert.ToBase64String(encoding.GetBytes(s));
            //return "http://localhost/ASPNETServer/mudis.png";
        }
        */
        #endregion

        #region Comments Methods
        public List<string> AddComment(Comment obj_Comment, string sessionId, string language, string tenantName, string userId, int tempid)
        {
            ERRORXML ErrorXML = null;
            StringBuilder sb_TempFilePath = null;
            StringBuilder sb_TempPath = null;
            String str_TempPath = null;
            ulong TempFolderID = 0;
            int AttachementOrder = 1;
            StringBuilder sb_ErrorMessage = null;
            StringBuilder FileContents = null;
            FileTransfer FileTransferObj = null;
            StringBuilder FileCollectionXML = null;
            StringBuilder PostXML = null;

            List<string> returnList = new List<string>();
            returnList.Add(tempid.ToString());

            Context ContextObj = null;
            StringBuilder sb_AdditionalInfo = null;
            sb_AdditionalInfo = new StringBuilder(100);
            try
            {

                SessionID = sessionId;
                Language = language;
                TenantName = tenantName;
                UserID = userId;

                ALCommon.GenerateUniqueID(ref TempFolderID);
                sb_TempPath = new StringBuilder(150);
                sb_TempFilePath = new StringBuilder(150);
                sb_ErrorMessage = new StringBuilder(100);
                str_TempPath = ALSolutionCommon.GetTempPath(SessionID);
                obj_PostFacade = new Post(SessionID, UserID, TenantName, Language);
                PostXML = new StringBuilder();
                PostXML.AppendFormat("<POST>");


                if (obj_Comment.CommentID > 0)
                {
                    PostXML.AppendFormat("<CommentID>{0}</CommentID>", obj_Comment.CommentID.ToString());
                }

                if (obj_Comment.CommentID == 0)
                {
                    //Applicable only in case of new post 
                    string owner = "0";
                    if (obj_Comment.AddedBy == 0)
                        owner = obj_Comment.AddedBy.ToString();
                    else
                        owner = UserID.ToString();

                    PostXML.AppendFormat("<POSTOWNER TYPE='RELATION'>{0}</POSTOWNER>", owner);

                    PostXML.AppendFormat("<TOPICPOST TYPE='RELATION'>{0}</TOPICPOST>", obj_Comment.DiscussionID.ToString());
                }

                //Append Attachements
                PostXML.AppendFormat("<FILESYSTEM>");
                PostXML.AppendFormat("<BINDER Operation='Create'>");
                PostXML.AppendFormat("<FIELDNAME>{0}</FIELDNAME>", AttachmentFieldName);
                PostXML.AppendFormat("<NAME>{0}</NAME>", "MESSAGEBOARD_POST_ATTACHMENTS");

                //Attach comments
                StringWriter writer = new StringWriter();
                XmlSerializer serializer = new XmlSerializer(typeof(Comment));
                serializer.Serialize(writer, obj_Comment);
                sb_TempPath.AppendFormat("{0}\\{1}", str_TempPath.ToString(), TempFolderID);
                Directory.CreateDirectory(sb_TempPath.ToString());
                sb_TempFilePath.AppendFormat("{0}\\comments.xml", sb_TempPath.ToString());

                FileStream fs = new FileStream(sb_TempFilePath.ToString(), FileMode.CreateNew);
                System.Text.UTF8Encoding encoding = new System.Text.UTF8Encoding();
                byte[] encodedDataAsBytes = encoding.GetBytes(writer.ToString());
                fs.Write(encodedDataAsBytes, 0, encodedDataAsBytes.Length);
                fs.Close();

                FileTransferObj = new FileTransfer(SessionID, UserID, TenantName, Language);

                FileContents = new StringBuilder();
                FileContents.AppendFormat("<FILE Operation='CREATE' Order='{0}'>", AttachementOrder.ToString());
                FileContents.AppendFormat("<FIELDNAME>{0}</FIELDNAME>", AttachmentFieldName);
                FileContents.AppendFormat("<PATH>{0}</PATH>", sb_TempFilePath);
                FileContents.AppendFormat("<NAME>{0}</NAME>", "comments.xml");
                FileContents.AppendFormat("<DISPLAYNAME>{0}</DISPLAYNAME>", "comments.xml");
                FileContents.AppendFormat("</FILE>");

                FileCollectionXML = new StringBuilder();
                FileCollectionXML.AppendFormat("<FILECOLLECTION>{0}</FILECOLLECTION>", FileContents.ToString());
                string commentsXML = FileCollectionXML.ToString();

                FileTransferObj.SaveFile(ref commentsXML);

                commentsXML = commentsXML.Replace("<FILECOLLECTION>", "");
                commentsXML = commentsXML.Replace("</FILECOLLECTION>", "");

                PostXML.AppendFormat("{0}", commentsXML);

                //Attach Background image
                AttachementOrder++;
                sb_TempFilePath.Remove(0, sb_TempFilePath.Length);
                sb_TempFilePath.AppendFormat("{0}\\Background.png", sb_TempPath.ToString());
                FileStream fs1 = new FileStream(sb_TempFilePath.ToString(), FileMode.CreateNew);
                byte[] encodedDataAsBytes1 = System.Convert.FromBase64String(obj_Comment.Background);
                fs1.Write(encodedDataAsBytes1, 0, encodedDataAsBytes1.Length);
                fs1.Close();

                FileTransferObj = new FileTransfer(SessionID, UserID, TenantName, Language);

                FileContents = new StringBuilder();
                FileContents.AppendFormat("<FILE Operation='CREATE' Order='{0}'>", AttachementOrder.ToString());
                FileContents.AppendFormat("<FIELDNAME>{0}</FIELDNAME>", AttachmentFieldName);
                FileContents.AppendFormat("<PATH>{0}</PATH>", sb_TempFilePath);
                FileContents.AppendFormat("<NAME>{0}</NAME>", "Background.png");
                FileContents.AppendFormat("<DISPLAYNAME>{0}</DISPLAYNAME>", "Background.png");
                FileContents.AppendFormat("</FILE>");

                FileCollectionXML = new StringBuilder();
                FileCollectionXML.AppendFormat("<FILECOLLECTION>{0}</FILECOLLECTION>", FileContents.ToString());
                String backgroundXML = FileCollectionXML.ToString();
                FileTransferObj.SaveFile(ref backgroundXML);

                backgroundXML = backgroundXML.Replace("<FILECOLLECTION>", "");
                backgroundXML = backgroundXML.Replace("</FILECOLLECTION>", "");

                PostXML.AppendFormat("{0}", backgroundXML);

                PostXML.AppendFormat("</BINDER>");
                PostXML.AppendFormat("</FILESYSTEM>");
                PostXML.AppendFormat("</POST>");

                String inputXML = PostXML.ToString();
                ErrorXML = obj_PostFacade.SavePost(ref inputXML);

                if (String.IsNullOrEmpty(ErrorXML))
                {
                    XPathDocument xpDoc = null;
                    xpDoc = new XPathDocument(new StringReader(inputXML));
                    XPathNavigator xpNav = xpDoc.CreateNavigator();
                    returnList.Add(xpNav.SelectSingleNode("POST/POSTID").Value);
                }
                else
                {
                    returnList.Add(ErrorXML);
                }

                sb_AdditionalInfo.Append(@"<ADDITIONALINFO>
                                                        <APINAME>ALCC_ALVisualAnnotation.Service.AddComment()</APINAME>
                                                        <THREADID>" + System.Threading.Thread.CurrentThread.ManagedThreadId.ToString() + "</THREADID>"
                                                        + PostXML.ToString()
                                                + "</ADDITIONALINFO>");
                ContextObj = new Context(Convert.ToUInt64(userId), Convert.ToUInt64(sessionId), tenantName, "ALVisualAnnotation", sb_AdditionalInfo.ToString());
            }
            catch (Exception obj_Exception)
            {
                sb_ErrorMessage.AppendFormat("{0}: {1}", Localization.GetString("ALErrorResource", TenantName, "EXCEPTION_shared"), obj_Exception.Message);
                returnList.Add(sb_ErrorMessage.ToString());
            }
            finally
            {
                try
                {
                    if (Directory.Exists(sb_TempPath.ToString()))
                    {
                        //Directory.Delete(sb_TempPath.ToString());
                        SASMOMDirectory.DeleteFolder(sb_TempFilePath.ToString(), ContextObj);
                    }
                }
                catch
                {
                    //do nothing
                }
            }
            return returnList;
        }

        public Comment GetComment(ulong DiscussionId, ulong CommentID)
        {
            Comment         obj_Comment         = null;
            ERRORXML        ErrorXML            = null;
            XML             str_PostXML         = null;
            XPathDocument   xpDoc_Post          = null;
            XPathNavigator  xpNav_Post          = null;
            String          str_FilePath        = null;

            try
            {
                obj_PostFacade  = new Post(SessionID, UserID, TenantName, Language);
                ErrorXML        = obj_PostFacade.GetPost(CommentID, "", "", ref str_PostXML);

                if (String.IsNullOrEmpty(ErrorXML))
                {
                    xpDoc_Post = new XPathDocument(new StringReader(str_PostXML));
                    xpNav_Post = xpDoc_Post.CreateNavigator();

                    ErrorXML = GetFile(xpNav_Post, AttachementType.Comments, out str_FilePath);
                    if (String.IsNullOrEmpty(ErrorXML) && File.Exists(str_FilePath))
                    {
                        XmlSerializer obj_XmlSerializer = new XmlSerializer(typeof(Comment));
                        TextReader obj_TextReader = new StreamReader(str_FilePath);
                        obj_Comment = (Comment)obj_XmlSerializer.Deserialize(obj_TextReader);

                        obj_TextReader.Close();
                    }
                }
            }
            catch (Exception obj_Exception)
            {
                string message = obj_Exception.Message;
            }
            return obj_Comment;

        }

        public List<string> GetCommentBackground(String Background_SchemaID, String Background_ObjectID, string sessionId, string language, string tenantName, string userId,string source,ulong commentId)
        {
            ERRORXML        ErrorXML                    = null;
            String          str_FilePath                = null;
            StringBuilder   sb_ErrorMessage             = null;
            StringBuilder   sb_FilePath                 = null;
            List<string>    returnList                  = new List<string>();
            
            
            SessionID = sessionId;
            Language = language;
            TenantName = tenantName;
            UserID = userId;

            try
            {
                returnList.Add(commentId.ToString());
                sb_FilePath = new StringBuilder(100);
                sb_ErrorMessage = new StringBuilder(100);
                ErrorXML  = GetFile(Background_ObjectID, "POSTATTACHMENTS",Background_SchemaID,"Background.png",false,out str_FilePath);
                sb_FilePath.AppendFormat("{0}{1}",ALSolutionCommon.GetHTTPDownloadFilePath(TenantName),str_FilePath.Substring(str_FilePath.LastIndexOf("\\")+1));

                if (!String.IsNullOrEmpty(ErrorXML))
                {
                    returnList.Add(ErrorXML.ToString());
                    returnList.Add(source);
                    return returnList;
                }
            }
            catch (Exception obj_Exception)
            {
                sb_ErrorMessage.AppendFormat("{0}: {1}", Localization.GetString("ALErrorResource", TenantName, "EXCEPTION_shared"), obj_Exception.Message);
                returnList.Add(sb_ErrorMessage.ToString());
                returnList.Add(source);
                return returnList;
            }
            returnList.Add(sb_FilePath.ToString());
            returnList.Add(source);
            return returnList;
        }

        public ERRORXML DeleteComment(String str_CommentIDList, string sessionId, string language, string tenantName, string userId)
        {
            StringBuilder   sb_CommentIDListXML     = null;
            String          CommentIDList           = null;
            ERRORXML        ErrorXml                = null;
            String[]        CommentIDs              = null;
            Post            obj_PostFacade          = null;

            try
            {
                SessionID = sessionId;
                Language = language;
                TenantName = tenantName;
                UserID = userId;

                obj_PostFacade      = new Post(SessionID, UserID, TenantName, Language);
                sb_CommentIDListXML = new StringBuilder();

                if (str_CommentIDList.Trim().Length > 0)
                {
                    CommentIDs = str_CommentIDList.Split(',');
                    sb_CommentIDListXML.AppendFormat("<POST>");
                    foreach (string PostID in CommentIDs)
                    {
                        sb_CommentIDListXML.AppendFormat("<POSTID>{0}</POSTID>", PostID);
                    }
                    sb_CommentIDListXML.AppendFormat("</POST>");
                    CommentIDList = sb_CommentIDListXML.ToString();

                    ErrorXml      = obj_PostFacade.DeletePost(CommentIDList.ToString(),"");
                    if (!String.IsNullOrEmpty(ErrorXml))
                    {
                        return ErrorXml;
                    }
                }
            }
            catch (Exception ExceptionObj)
            {
                ErrorXml =  ExceptionObj.Message;
            }
            return ErrorXml;
        }
        #endregion

        #region Discussion Methods
        public Discussion GetDiscussion(ulong DiscussionId, string sessionId, string language, string tenantName, string userId,List<string> reviewerList)
        {
            Topic               obj_TopicFacade                 = null;
            XML                 xml_TopicPostList               = null;
            ERRORXML            ErrorXML                        = null;
            XPathDocument       xpDoc_TopicPostList             = null;
            XPathNavigator      xpNav_TopicPostList             = null;
            XPathNodeIterator   xpNodItr_PostList               = null;
            XPathDocument       xpDoc_Topic                     = null;
            XPathNavigator      xpNav_Topic                     = null;
            String              str_FilePath                    = null;
            ulong               CommentID                       = 0;
            Discussion          obj_Discussion                  = null;
            StringBuilder       sb_ErrorMessage                 = null;
            String              str_TopicXML                    = null;
            String              str_SourceFilePath              = null;
            String[]            str_sourceResolution            = null;
            StringBuilder       sb_SourceFilePath               = null;
            Int32               SourceWidth                     = 0;
            Int32               SourceHeight                    = 0;
            
            SessionID       = sessionId;
            Language        = language;
            TenantName      = tenantName;
            UserID          = userId;

            try
            {
                obj_Discussion      = new Discussion();
                obj_TopicFacade     = new Topic(SessionID, UserID, TenantName, Language);
                ErrorXML            = obj_TopicFacade.GetPostList(DiscussionId, out xml_TopicPostList);
                sb_ErrorMessage     = new StringBuilder(100);

                if (String.IsNullOrEmpty(ErrorXML))
                {
                    xpDoc_TopicPostList = new XPathDocument(new StringReader(xml_TopicPostList));
                    xpNav_TopicPostList = xpDoc_TopicPostList.CreateNavigator();
                    xpNodItr_PostList   = xpNav_TopicPostList.Select("TOPICCOLLECTION/TOPIC/TOPICPOST/POST");
                    foreach (XPathNavigator xpNav_Post in xpNodItr_PostList)
                    {
                        if (reviewerList.Count == 0 || reviewerList.Contains(xpNav_Post.SelectSingleNode("POSTOWNER/USER/USERID").Value))
                        {
                            ErrorXML = GetFile(xpNav_Post, AttachementType.Comments, out str_FilePath);
                            if (String.IsNullOrEmpty(ErrorXML) && File.Exists(str_FilePath))
                            {
                                XmlSerializer obj_XmlSerializer = new XmlSerializer(typeof(Comment));
                                TextReader obj_TextReader       = new StreamReader(str_FilePath);
                                Comment obj_Comment             = (Comment)obj_XmlSerializer.Deserialize(obj_TextReader);
                                obj_Comment.DiscussionID        = DiscussionId;
                                ulong.TryParse(xpNav_Post.SelectSingleNode("POSTID").Value, out CommentID);
                                obj_Comment.CommentID           = CommentID;

                                obj_Comment.AddedBy             = ulong.Parse(xpNav_Post.SelectSingleNode("POSTOWNER/USER/USERID").Value);
                                obj_Comment.AddedBy_LoginName   = xpNav_Post.SelectSingleNode("POSTOWNER/USER/LOGINNAME").Value;
                                obj_Comment.AddedBy_FirstName   = xpNav_Post.SelectSingleNode("POSTOWNER/USER/FIRSTNAME").Value;
                                obj_Comment.AddedBy_LastName    = xpNav_Post.SelectSingleNode("POSTOWNER/USER/LASTNAME").Value;

                                SetBackgroundParameters(xpNav_Post, obj_Comment);

                                obj_Discussion.CommentList.Add(obj_Comment);
                                obj_TextReader.Close();
                            }
                        }
                    }

                    obj_Discussion.CreatedBy    = Convert.ToUInt64(xpNav_TopicPostList.SelectSingleNode("TOPICCOLLECTION/TOPIC/TOPICOWNER/USER/USERID").Value);
                    obj_Discussion.DiscussionId = Convert.ToUInt64(DiscussionId);


                }

                ErrorXML = obj_TopicFacade.GetTopic(DiscussionId.ToString(), null, null, ref  str_TopicXML);
                if (String.IsNullOrEmpty(ErrorXML))
                {
                    xpDoc_Topic             = new XPathDocument(new StringReader(str_TopicXML));
                    xpNav_Topic             = xpDoc_Topic.CreateNavigator();
                    ErrorXML                = GetSourceFile(xpNav_Topic, out str_SourceFilePath);
                    sb_SourceFilePath       = new StringBuilder(100);
                    sb_SourceFilePath.AppendFormat("{0}{1}", ALSolutionCommon.GetHTTPDownloadFilePath(TenantName), str_SourceFilePath.Substring(str_SourceFilePath.LastIndexOf("\\") + 1));
                    obj_Discussion.Source   = sb_SourceFilePath.ToString();
                    if (!String.IsNullOrEmpty(xpNav_Topic.SelectSingleNode("TOPIC/TOPICDESCRIPTION").Value))
                    {
                        str_sourceResolution            = xpNav_Topic.SelectSingleNode("TOPIC/TOPICDESCRIPTION").Value.Split(new Char[] { 'X' });
                        if (int.TryParse(str_sourceResolution[0], out SourceWidth))
                            obj_Discussion.SourceWidth  = SourceWidth;
                        if (int.TryParse(str_sourceResolution[1], out SourceHeight))
                            obj_Discussion.SourceHeight  = SourceHeight;
                    }
                    
                }

            }
            catch(Exception ex)
            {
                throw ex;
                 //sb_ErrorMessage.AppendFormat("{0}: {1}",Localization.GetString("ALErrorResource", TenantName, "EXCEPTION_shared"),obj_Exception.Message);

            }
            return obj_Discussion;
        }
        #endregion

        #region Private Methods
        ERRORXML GetFile(XPathNavigator xpNav_Post, AttachementType attachementType, out String str_FilePath)
        {
            ERRORXML            ErrorXML            = null;
            StringBuilder       sb_FileXML          = null;
            String              str_ObjectID        = null;
            String              str_FieldName       = null;
            String              str_SchemaID        = null;
            String              str_FileName        = null;
            XPathNavigator      xpNav_FileSystem    = null;
            String              str_Xpath           = null;
            String              str_ErrorMessage    = null;
            Boolean           OverWriteExistingFile = true;
                                str_FilePath        = String.Empty;
                                sb_FileXML          = new StringBuilder(100);
            try
            {

                switch (attachementType)
                {
                    case AttachementType.Comments:
                        {
                            str_Xpath               = "FILESYSTEM/BINDER/FILE/NAME[text()='comments.xml']";
                        } break;
                    case AttachementType.Background:
                        {
                            str_Xpath               = "FILESYSTEM/BINDER/FILE/NAME[text()='Background.png']";
                        } break;
                    case AttachementType.Thumbnail:
                        {
                            str_Xpath               = "FILESYSTEM/BINDER/FILE/NAME[text()='Thumbnail.png']";
                        } break;
                }
                xpNav_FileSystem = xpNav_Post.SelectSingleNode(str_Xpath);

                if (xpNav_FileSystem != null)
                {
                    xpNav_FileSystem.MoveToParent();
                    str_ObjectID    = xpNav_FileSystem.SelectSingleNode("OBJECTID").Value;
                    str_FieldName   = xpNav_FileSystem.SelectSingleNode("FIELDNAME").Value;
                    str_SchemaID    = xpNav_FileSystem.SelectSingleNode("SCHEMAID").Value;
                    str_FileName    = xpNav_FileSystem.SelectSingleNode("NAME").Value;
                }
                else
                {
                    str_ErrorMessage = Localization.GetString("ALErrorResource", TenantName, "ERR_GETFILE_FAILED_shared");
                    return str_ErrorMessage;
                }

                ErrorXML =  GetFile(str_ObjectID, str_FieldName, str_SchemaID, str_FileName,OverWriteExistingFile, out str_FilePath);
                if (ErrorXML != null)
                {
                    str_ErrorMessage = Localization.GetString("ALErrorResource", TenantName, "ERR_GETFILE_FAILED_shared");
                    return str_ErrorMessage;
                }
                return ErrorXML;
            }
            catch (Exception obj_Exception)
            {
                return obj_Exception.Message;
            }
        }

        ERRORXML GetFile(String str_ObjectID, String str_FieldName, String str_SchemaID, String str_FileName,Boolean OverWriteExisitingFile, out String str_FilePath)
        {
            ERRORXML            ErrorXML                = null;
            StringBuilder       sb_FileXML              = null;
            StringBuilder       sb_FilePath             = null;
             StringBuilder      sb_CopyFilePath         = null;
            String              str_FileXML             = null;
            String              str_ErrorMessage        = null;
            String              FilePathOnServer        = null;
            StringBuilder       sb_DownloadFileName     = null;
            XPathDocument       xpDoc_FileSystem        = null;
            XPathNavigator      xpNav_FileSystem        = null;
            str_FilePath        = String.Empty;
            sb_FileXML          = new StringBuilder(100);
            try
            {   
                #region Check file is present in DownloadFiles
                obj_FileTransfer        = new FileTransfer(SessionID, UserID, TenantName, Language);
                sb_FilePath             = new StringBuilder(100);
                sb_DownloadFileName     = new StringBuilder(100);

                sb_DownloadFileName.AppendFormat("{0}_{1}_{2}", str_ObjectID, SessionID, str_FileName);
                if (!OverWriteExisitingFile)
                {
                    sb_FilePath.AppendFormat("{0}{1}", ALSolutionCommon.GetDownloadFilePath(TenantName), sb_DownloadFileName.ToString());
                    if (File.Exists(sb_FilePath.ToString()))
                    {
                        str_FilePath = sb_FilePath.ToString();
                        return null;
                    }
                    else
                    {
                        sb_DownloadFileName.Remove(0, sb_DownloadFileName.Length);
                        sb_FilePath.Remove(0, sb_FilePath.Length);
                        sb_DownloadFileName.AppendFormat("{0}_{1}", str_ObjectID, str_FileName);
                        sb_FilePath.AppendFormat("{0}{1}", ALSolutionCommon.GetDownloadFilePath(TenantName), sb_DownloadFileName.ToString());
                        if (File.Exists(sb_FilePath.ToString()))
                        {
                            sb_CopyFilePath = new StringBuilder(100);
                            sb_CopyFilePath.AppendFormat("{0}{1}_{2}_{3}", ALSolutionCommon.GetDownloadFilePath(TenantName), str_ObjectID, SessionID, str_FileName);
                            File.Copy(sb_FilePath.ToString(), sb_CopyFilePath.ToString());
                            str_FilePath = sb_CopyFilePath.ToString();
                            return null;
                        }
                    }
                }
                #endregion
                #region Get File in OutBox
                sb_FileXML.AppendFormat("<FILESYSTEM ObjectID='{0}'>", str_ObjectID);
                sb_FileXML.AppendFormat("<FILE FileRequired='YES'>");
                sb_FileXML.AppendFormat("<FIELDNAME>{0}</FIELDNAME>", str_FieldName);
                sb_FileXML.AppendFormat("<OBJECTID>{0}</OBJECTID>", str_ObjectID);
                sb_FileXML.AppendFormat("<SCHEMAID>{0}</SCHEMAID>", str_SchemaID);
                ALSolutionCommon.EncodeSpecialCharacters(ref str_FileName);
                sb_FileXML.AppendFormat("<NAME>{0}</NAME>", str_FileName);
                sb_FileXML.AppendFormat("</FILE>");
                sb_FileXML.AppendFormat("</FILESYSTEM>");
                str_FileXML = sb_FileXML.ToString();

                //Retreiving the files from the OM Reporsitory
                obj_FileFacade = new FileFacade(SessionID, UserID, TenantName, Language);
                ErrorXML       = obj_FileFacade.GetFile(ref str_FileXML);
                if (ErrorXML != null)
                {
                    str_ErrorMessage = Localization.GetString("ALErrorResource", TenantName, "ERR_GETFILE_FAILED_shared");
                    return str_ErrorMessage;
                }
                #endregion

                #region Get File on IIS
                xpDoc_FileSystem = new XPathDocument(new StringReader(str_FileXML));
                xpNav_FileSystem = xpDoc_FileSystem.CreateNavigator();
                FilePathOnServer = xpNav_FileSystem.SelectSingleNode("FILESYSTEM/FILE/PATH").Value;
                FilePathOnServer = ALSolutionCommon.TrimAndReplaceSpecialChars(FilePathOnServer);
                sb_FileXML = new StringBuilder(100);
                sb_FileXML.AppendFormat("<FILESYSTEM><FILE FileRequired='YES'><SOURCEPATH>{0}</SOURCEPATH></FILE></FILESYSTEM>", FilePathOnServer);
                sb_FileXML.Replace("''", "'");
                str_FileXML = sb_FileXML.ToString();
                //Retrieving the files from the Service machine
                //Check for media streaming
                
                obj_FileTransfer.GetFilePath = ALSolutionCommon.GetDownloadFilePath(TenantName);
                obj_FileTransfer.DownloadFileName = sb_DownloadFileName.ToString();
                ErrorXML = obj_FileTransfer.GetFile(ref str_FileXML);
                if (ErrorXML != null)
                {
                    str_ErrorMessage = Localization.GetString("ALErrorResource", TenantName, "ERR_GETFILE_FAILED_shared");
                    return str_ErrorMessage;
                }
                str_FilePath = obj_FileTransfer.GetFilePath + sb_DownloadFileName.ToString();
                #endregion
            }
            catch (Exception obj_Exception)
            {
                return obj_Exception.Message;
            }
            return ErrorXML;
        }

        private void CreateFileNode(XmlDocument xmlDoc_Post, XmlElement xmlEle_Binder, String str_FileName, String str_FilePath, String str_Order)
        {
            XmlElement xmlEle_File  = null;
            XmlElement xmlEle_Field = null;

            xmlEle_File             = xmlDoc_Post.CreateElement("FILE");
            xmlEle_File.SetAttribute("Operation", "Create");
            xmlEle_File.SetAttribute("Order", str_Order);
            xmlEle_Binder.AppendChild(xmlEle_File);

            xmlEle_Field            = xmlDoc_Post.CreateElement("FIELDNAME");
            xmlEle_Field.InnerText  = AttachmentFieldName;
            xmlEle_File.AppendChild(xmlEle_Field);

            xmlEle_Field            = xmlDoc_Post.CreateElement("DISPLAYNAME");
            xmlEle_Field.InnerText  = str_FileName;
            xmlEle_File.AppendChild(xmlEle_Field);

            xmlEle_Field            = xmlDoc_Post.CreateElement("NAME");
            xmlEle_Field.InnerText  = str_FileName;
            xmlEle_File.AppendChild(xmlEle_Field);

            xmlEle_Field            = xmlDoc_Post.CreateElement("PATH");
            xmlEle_Field.InnerText  = str_FilePath;
            xmlEle_File.AppendChild(xmlEle_Field);
        }

        void SetBackgroundParameters(XPathNavigator xpNav_Post, Comment obj_Comment)
        {
            XPathNavigator xpNav_FileSystem = null;
            xpNav_FileSystem = xpNav_Post.SelectSingleNode("FILESYSTEM/BINDER/FILE/NAME[text()='comments.xml']");

            if (xpNav_FileSystem != null)
            {
                xpNav_FileSystem.MoveToParent();
                obj_Comment.Background_ObjectID     = xpNav_FileSystem.SelectSingleNode("OBJECTID").Value;
                obj_Comment.Background_SchemaID     = xpNav_FileSystem.SelectSingleNode("SCHEMAID").Value;
                obj_Comment.Background_FileID       = xpNav_FileSystem.SelectSingleNode("FILEID").Value;
            }
        }

        ERRORXML GetSourceFile(XPathNavigator xpNav_Topic, out String SourcePath)
        {


            XPathNavigator xpNav_File = null;
            String str_ObjectID = null;
            String str_FieldName = null;
            String str_SchemaID = null;
            String str_FileName = null;
            ERRORXML ErrorXML = null;
            SourcePath = String.Empty;
            try
            {
                xpNav_File = xpNav_Topic.SelectSingleNode("TOPIC/FILESYSTEM/BINDER/FILE");
                str_ObjectID = xpNav_File.SelectSingleNode("OBJECTID").Value;
                str_FieldName = xpNav_File.SelectSingleNode("FIELDNAME").Value;
                str_FileName = xpNav_File.SelectSingleNode("NAME").Value;
                str_SchemaID = xpNav_File.SelectSingleNode("SCHEMAID").Value;

                ErrorXML = GetFile(str_ObjectID, str_FieldName, str_SchemaID, str_FileName,false, out SourcePath);

            }
            catch (Exception obj_Exception)
            {
                string message = obj_Exception.Message;

            }
            return ErrorXML;
        }
        #endregion
       
    }
}
